package test.application;


import java.util.ArrayList;
import yaes.application.marketgrid.clients.SerialClient;
import yaes.application.marketgrid.resource.IPricingRule;
import yaes.application.marketgrid.resource.IResource;
import yaes.application.marketgrid.resource.simple.SimplePricePolicy;
import yaes.application.marketgrid.resource.simple.SimplePricingRule;
import yaes.application.marketgrid.resource.simple.SimpleResource;
import yaes.framework.world.World;

public class ResourceTest{

    SimpleResource resource;
    SimplePricePolicy price;
    boolean busy;
    World world = new World();
  /*
    Runs basic test of SimpleResource (allocation / release of resources
    allocated by various agents
  */
  public static void main(String[] args){
    ResourceTest test = new ResourceTest();
    test.runTest();
  }

  private void runTest(){
    resource = new SimpleResource();
    resource.setTotalQuantity(200.0);
    SimplePricingRule priceRule = new SimplePricingRule(10.0);
    ArrayList<IPricingRule> pricingRules = new ArrayList<IPricingRule>();
    pricingRules.add(priceRule);
    resource.setPricingPolicy(pricingRules);
    price = new SimplePricePolicy();
    busy = true;
    TR t1 = new TR();
    TR t2 = new TR();
    new Thread(t1, "FIRST").start();
    new Thread(t2, "SECON").start();
    busy = false;
  }

  double calculate(double quantity, IResource resource){

    //Collection<IPricingRule> pricingRules = ;
    return price.getPrice(quantity, resource.getPricingPolicy());
  }

  private class TR implements Runnable{
    public void run(){
       
      // clients have to be thread safe!!
      ArrayList<SerialClient> clients = new ArrayList<SerialClient>();
      String name = Thread.currentThread().getName();
      for(int i=0; i < 10; i++){
        System.out.println("\nPass "+name+" "+i);
        SerialClient user = new SerialClient("CLIENT "+name+" "+i, world, 100, 3, 1000);
        clients.add(user);
        double allocated = resource.allocate((i+1)*5.0, user.getName(), false);
        double value = calculate(resource.getAvailableQuantity(), resource);
        System.out.println("allocated  " + allocated + " available " + resource.getAvailableQuantity()+ " value " + value);
      }

      System.out.println("\nRELEASE ");
      int i = 0;
      for(SerialClient user : clients){
        System.out.println("\nPass "+name+" "+i);
        resource.release((i+1)*4.0, user.getName());
        double value = calculate(resource.getAvailableQuantity(), resource);
        System.out.println(" available " + resource.getAvailableQuantity()+ " value " + value);
        i++;
      }
    }
  }
}

