/*

 * Created on Dec 6, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.application.clustering;



import java.util.ArrayList;

import java.util.Iterator;



import yaes.framework.simulation.IContext;

import yaes.framework.simulation.ISimulationCode;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.sensornetwork.SensorNetworkHelper;

import yaes.framework.world.network.sensornetwork.SensorNode;

import yaes.ui.text.TextUi;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class MobilitySimulation implements ISimulationCode, Constants {



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#setup(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.IContext)

     */

    public void setup(SimulationInputParameters sip, IContext theContext) {

        ClusteringContext context = (ClusteringContext) theContext;        

        SensorNetworkHelper.generateRandomNetwork(context.n, sip

                                                  .getParameterInteger(NODECOUNT), (int)sip

                                                  .getParameterDouble(TRANSMISSION_RANGE));

        initializeDistances(context);

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#update(double, yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void update(double time, SimulationInputParameters sip, SimulationOutputParameters sop, IContext theContext) {

        ClusteringContext context = (ClusteringContext) theContext;        

        //updateDistances(context);

        SensorNetworkHelper.changeNodeCoordinate(context.n, (int)time, sip.getParameterInteger(MAX_DISPLACEMENT));

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#postprocess(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void postprocess(SimulationInputParameters sip, SimulationOutputParameters sop, IContext theContext) {

        // nothing here

    }

    

    private void initializeDistances(ClusteringContext context) {

        for (Iterator iter = context.n.nodeInfoList.iterator(); iter.hasNext();) {

            SensorNode element = (SensorNode) iter.next();

            ArrayList distances = new ArrayList();

            context.distanceToTheClusterHead.put(element, distances);

        }

    }

    

    

    /**

     * Updates the distances model in the 

     *

     */

    private void updateDistances(ClusteringContext context) {

        try {

        for (Iterator iter = context.n.nodeInfoList.iterator(); iter.hasNext();) {

            SensorNode element = (SensorNode) iter.next();

            ClusterHead ch = element.getMasterClusterHead();

            double distance = element.distance(ch.getTheNode());

            ArrayList distances = (ArrayList) context.distanceToTheClusterHead.get(element);

            distances.add(new Double(distance));

        }

        } catch(Error error) {

            TextUi.errorPrint(error.toString());

        }

    }

    

}

