/*

 * Created on Dec 5, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.application.clustering;



import java.io.IOException;

import java.util.Iterator;

import yaes.framework.algorithm.routing.wca.ConnectivityCalculation2;

import yaes.framework.algorithm.routing.wca.WeightedClusteringAlgorithm;

import yaes.framework.simulation.IContext;

import yaes.framework.simulation.ISimulationCode;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.sensornetwork.SensorNode;

import yaes.ui.plot.SimulationPlot;



/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class WCASimulation implements ISimulationCode, Constants {



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#setup(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.IContext)

     */

    public void setup(SimulationInputParameters sip, IContext theContext) {

        ClusteringContext context = (ClusteringContext) theContext;

        context.wca = new WeightedClusteringAlgorithm(context.n, context.wcapar);

        context.wca.computeOriginalClusters(0.0, sip.getParameterInteger(MAX_DISPLACEMENT));

        context.am.acctClusterHead += context.n.clusterHeadSet.size();

        /*

         ConnectivityCalculation2 cc = new ConnectivityCalculation2(context.n);

         double connectivity = cc.calculateConnectivity(1.5);

         double std = context.n.standardDeviationOfClusterSize(context.n.clusterHeadSet);

         */

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#update(double, yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void update(double time, SimulationInputParameters sip,

            SimulationOutputParameters sop, IContext theContext) {

        ClusteringContext context = (ClusteringContext) theContext;

        //   ... if the clusterHeadSet need to be changed

        boolean force = (sip.getParameterInteger(WCA_FORCED_RECOMPUTE) == WCA_FORCED_RECOMPUTE_YES);

        if (force || context.wca.doesClusterHeadSetChange(context.am)) {

            //   ... keep track the total number of CH change

            context.am.numberOfCHChange++;

            //   ... update the totalCHTime before finding the new

            //   ... dominant set

            context.n.updateTotalCHTime((int) context.startTime, (int) time);

            //   ... reset startTime with the current time ( time )

            context.startTime = time;

            //   ... update the number of clusterHead set

            context.am.dominantSetUpdate++;

            context.wca.computeOriginalClusters(time, sip.getParameterInteger(MAX_DISPLACEMENT));

            double std = context.n

                    .standardDeviationOfClusterSize(context.n.clusterHeadSet);

            //lbf = 1 / std;

            //stdWhenDSChange += std;

            //TextUi.println("CHChange yes " + context.n.clusterHeadSet.size());

        } else {

            //TextUi.println("CHChange no" + context.n.clusterHeadSet.size());

            //   ... otherwise

            //   ... the CH set does not change, so we need to update

            //   ... the number of times ch's neighbor changes it's

            // clusterhead

            //   ... update the number of times that clusterhead 's neighbors

            //   ... changes to other clusterhead in the same dominant set

            context.am.noCHChanges += context.am.noTimesNeighborChange;

            double std = context.n

                    .standardDeviationOfClusterSize(context.n.clusterHeadSet);

            // lbf = 1 / std;

        }

        sop.update(NO_CLUSTERHEADS, context.n.clusterHeadSet.size());

        ConnectivityCalculation2 cc = new ConnectivityCalculation2(context.n);

        sop.update(CONNECTIVITY, cc.calculateConnectivity()); // previous 1.5

        // distance measurements

        if (sip.getParameterInteger(RECORD_DISTANCES) == RECORD_DISTANCES_YES) {

        for (Iterator iter = context.n.clusterHeadSet.iterator(); iter

                .hasNext();) {

            ClusterHead element = (ClusterHead) iter.next();

            updateMemberDistances(element);

        }

        }

    }



    /* (non-Javadoc)

     * @see yaes.framework.simulation.ISimulationCode#postprocess(yaes.framework.simulation.SimulationInputParameters, yaes.framework.simulation.SimulationOutputParameters, yaes.framework.simulation.IContext)

     */

    public void postprocess(SimulationInputParameters sip,

            SimulationOutputParameters sop, IContext theContext) {

        // print out the distances

        ClusteringContext context = (ClusteringContext) theContext;

        for (Iterator iter = context.n.nodeInfoList.iterator(); iter.hasNext();) {

            SensorNode element = (SensorNode) iter.next();

            SimulationPlot distancePlot = new SimulationPlot();

            double x[] = new double[element.chDistanceList.size()];

            double y[] = new double[element.chDistanceList.size()];

            //TextUi.println("Distance series for node: ");

            int cnt = 0;

            for (Iterator iterator = element.chDistanceList.iterator(); iterator

                    .hasNext();) {

                Double d = (Double) iterator.next();

                x[cnt] = cnt;

                y[cnt] = d.doubleValue();

                cnt++;

                //TextUi.print(d.toString() + ", ");

            }

            distancePlot.setXPoints(x);

            distancePlot.addOnePlot("Distance", y);

            try {

                distancePlot.generateMatlabPlotFileWithLegend("distancePlot.m");

            } catch (IOException ioex) {

                ioex.printStackTrace();

            }

            break;

            //TextUi.println("Done");

        }

        // TODO Auto-generated method stub

    }



    /**

     * For all the members of the cluster of the elements, add the new distance

     * 

     * @param element

     */

    private static void updateMemberDistances(ClusterHead element) {

        for (Iterator iter = element.getClusterContentIterator(); iter.hasNext();) {

            SensorNode ex = (SensorNode) iter.next();

            double distance = element.getTheNode().distance(ex);

            ex.chDistanceList.add(new Double(distance));

        }

    }

}

