/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents;

import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.classagents.cxbr.*;
import yaes.application.eel6938.game.Configuration;

/**
 * This class represents a CxBR controlled Agent
 * @author Viet Trinh
 *
 */
public class CxBRAgent extends Agent 
{
	private CxBR_Engine _cxbr = null;
	private int _color[] = null;
	
	public String NAME = "CxBR Agent";
	public static final String REAL_NAME = "CxBR Agent";
	public static final int ATTACK_MARGIN = 1000;
	public static final int ATTACK_MIN_ENERGY = 1000;
	public static final int NEAR_DEATH_MIN_ENERGY = Configuration.AgentInitialEnergyLevel / 2;//Configuration.AgentAttackedCost + Configuration.AgentMateCost + 100;
	public static final int MATE_INTERVAL = 100;
	public static final double MATE_PROB = 0.05;//The probability for the each child during the matting period
	public static final int MAX_CHILDREN = 2;	//The maximum number of children you are allowed to have
	public static final int MAX_NEAR_DEATH_CHILDREN = MAX_CHILDREN * 2;
	
	/**
	 * Constructor
	 *
	 */
	public CxBRAgent() 
	{
		super();
		this._cxbr = new CxBR_Engine(this);
	}

	@Override
	public void intelligence() 
	{
		this._cxbr.execute();
		this._color = this._cxbr.getColor();
	}

	@Override
	public String getName() 
	{
		return NAME;
	}

	@Override
	public int[] getColor() 
	{
		//return this._color;
		int[] rgb = new int[3];
		rgb[0]=0; rgb[1]=255; rgb[2]=255; 
		return rgb;
	}

}
