/*
 * Created on March 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.classagents;

import java.awt.Point;

import yaes.application.eel6938.classagents.expertagent.History;
import yaes.application.eel6938.classagents.expertagent.LocalMap;
import yaes.application.eel6938.classagents.expertagent.Step;
import yaes.application.eel6938.classagents.expertagent.UtilityEvaluator;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
/*
 * @author Majid Khan
 *	This agent uses heuristics for dealing with environment and
 *  game theoretic behavior for interacting with other agents.
 *  The details will be provided in the project documentation. 
 */
public class ExpertAgent extends Agent {

	private int direction = 0;		//Keep track of direction
	private int failCount = 1;		//If command failed too many times a direction switch is needed
	private int successCount = 1;	//If command succeeded too many times a direction switch is needed

	private long stepCounter = 0; // counts the steps
	private int eatFailure = 0; // determine number of eat failures
	
	private  int agentInScope = -1;
	private final int NumberOfDistances = 40;
	private double[] distanceWithAgent = new double[NumberOfDistances];
    private int distanceIndex=-1;

	private boolean m_agent_approaching = false;
	private boolean m_agent_approaching_to_attack = false;
	private boolean m_agent_fleeing = false;
	private boolean m_agent_attacked = false;
	/**
	 * 
	 */
	public ExpertAgent() {
		super();
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#intelligence()
	 */
	
	public void intelligence() {
		// Build local map information
		stepCounter++;
		LocalMap  myMap = new LocalMap();
		myMap.buildMapInformation(getSensorAgentList(),(byte)Constants.ContentAgent);
		myMap.buildMapInformation(getSensorFoodList(),(byte)Constants.ContentFood);
		myMap.buildMapInformation(getSensorObstacleList(),(byte)Constants.ContentObstacle);
		Step myStep = new Step(stepCounter,myMap);
		// Store this step for historical records
		History.getInstance().addStep(myStep);
		// Store movement directions in hostorical records
		History.getInstance().setMovementDirection(direction);

		// Counter number of commands since last eating
		// Heuristic:if it exceeds a limit, change direction (explore map for food)
		if (getLastCommandType() != Constants.CommandEat) eatFailure++;

		// Heuristic: Generally, if agent is stuck somewhere, count command failures
		if(!wasLastCommandSuccessful())
		{
			//System.out.println(getId() + ": Last command failed:" + failCount);
			failCount++;
			successCount = 1;
		}
		else
		{
			successCount++;
			failCount = 1;
		}
		int oldDirection = direction;		
		// Heuristic: If either a command failed or agent is starving out of food, change directions
		// Heuristic: If changing directions results in further failures, try 
		// 			random movement behavior to get out of current situation
		if (failCount >= 6) {
			while(direction == oldDirection) //Make sure we don't move in the same direction
			{
				direction = (int)(Math.random()*Constants.Directions.length);
			}
			move(direction,1);
			return;
		}
		else if((failCount > 2 && failCount <10) || (eatFailure%100==0))	//Change direction!
		{
			displayMessage("Chaging direction: "+direction+"... Eat failures:" + eatFailure);
			// Get directions based on historical data
			// Heuristic: Choose direction that has been less traveresed yet.
			int newDirection = History.getInstance().getSuggestedMovementDirection();
			if (newDirection == -1 || newDirection == oldDirection || eatFailure > 200) {
				while(direction == oldDirection) //Make sure we don't move in the same direction
				{
					direction = (int)(Math.random()*Constants.Directions.length);
				}
			} else {
				displayMessage("Suggested direction:" + newDirection + "old direction:" + direction);
				direction = newDirection;
			}
			if (canMove(direction,2))
				this.move(direction, 2);
			else
				this.move(direction, 1);
			return;
			//failCount =  1;
		}
		
/*		if(successCount % 1000 == 0)	//Change direction!
		{
			int oldDirection = direction;
			while(direction == oldDirection) //Make sure we don't move in the same direction
			{
				direction = (int)(Math.random()*Constants.Directions.length);
			}
			move(direction, 4);
			successCount =  1;
		}
*/
		//Are there any agents in sensor scope?
		if(getSensorAgentList().length == 2)	//Agents in sight
		{
			/*
			for (int i=0; i<getSensorAgentList().length; i++) {
				Point agent = getSensorAgentList()[i];
				agentID = getId(agent);
				displayMessage("Agent ID:" + getId(agent)+ ", X:"+ agent.getX() + ", Y:"+ agent.getY());
				History.getInstance().getAgentHistory(agentID).setAgentName(getName(agent));
				//myMap.setMapInformation((int)agent.getX(),(int)agent.getY(),Constants.ContentAgent);
			}*/
			//Get second agent element, which is also the closest agent element by default (the first element is this agent)
			Point agent = getSensorAgentList()[1];
			extractAgentInformation(agent);
			handleOneAgent(agent);
		}
		else if(getSensorAgentList().length > 2)	//Agents in sight
		{
			resetAgentInformation();
			fleeMultipleAgents();
		}
		else if(this.getSensorFoodList().length > 0)	//Food in sight
		{
			resetAgentInformation();
			approachAndEatFood();
		}
		else if (getEnergyLevel() > 30000) {
			resetAgentInformation();
			if (canMate()) {
				mate();
			}
		}
		else {
			resetAgentInformation();
			if (canMove(direction,2))	
				move(direction, 2);	//Default action.
			else
				move(direction, 1);	//Default action.
		}	
	}
	private void handleOneAgent(Point agent) {
		int agentID = -1;
		//oneAgentHandleHeuristic(agent);
		oneAgentGameTheoretic(agent);
		
	}
	private void extractAgentInformation(Point agent) {
		double distance=0;
		distance = computeDistance(agent);
		// Met a new agent
		if (agentInScope == -1) {
			agentInScope = getId(agent);
			distanceIndex++;
			distanceWithAgent[distanceIndex] = distance;
		}
		// if this is second or greater interaction
		if (distanceIndex > 1) {
			// if distance is getting smaller
			if (distanceWithAgent[distanceIndex] < distanceWithAgent[distanceIndex-1]) {
				// agent is approaching near my agent
				m_agent_approaching = true;
				// if agent in vicinity
				if (distance < 5) m_agent_approaching_to_attack = true;
				// if agent has attacked
				if (canFlee()) {
					m_agent_attacked = true;
					History.getInstance().getAgentHistory(agentInScope).setAgentBehavior(Constants.CommandAttack);
				}
			}
			// else if distance is getting larger
			else if (distanceWithAgent[distanceIndex] > distanceWithAgent[distanceIndex-1]) {
				if (distance > 10) {
					m_agent_fleeing = true;
					History.getInstance().getAgentHistory(agentInScope).setAgentBehavior(Constants.CommandFlee);
				}
			}
		}
	}
	private void resetAgentInformation() {
		agentInScope = -1;
		distanceIndex = -1;
		m_agent_approaching = false;
		m_agent_fleeing = false;
		m_agent_approaching_to_attack = false;
		m_agent_attacked = false;
		for (int i=0; i<NumberOfDistances; i++)
			distanceWithAgent[i] = 0;
	}
	private void oneAgentGameTheoretic(Point agent) {
		UtilityEvaluator eval = UtilityEvaluator.getInstance();
		int deltaStrength = getEnergyLevel() - getEnergyLevel(agent);
		int action = eval.getOptimalStrategy(agentInScope, deltaStrength);
		//System.out.println(agentInScope + ": " + action);
		if (action == Constants.CommandAttack)
			approachAndAttack(agent);
		else if (action == Constants.CommandFlee)
			fleeMultipleAgents();
		else if (this.getSensorFoodList().length > 0)
			approachAndEatFood();
		else {
			if (canMove(direction,4))
				move(direction,4);
			else
				move(direction,1);
		}
			
	}
	private void oneAgentHandleHeuristic(Point agent) {
		if (getName(agent).equalsIgnoreCase("ExpertAgent")) {
			if(this.getSensorFoodList().length > 0)
				approachAndEatFood();
			else {
				if (canMove(direction,4))
					move(direction,4);
				else
					move(direction,1);
			}
			return;
		}
		displayMessage("Found agent in neighbourhood:"+getName(agent));
		displayMessage("My Energy:" + getEnergyLevel() + " and other energy:" + getEnergyLevel(agent));	
		if (getEnergyLevel()>getEnergyLevel(agent)) {
			//System.out.println("attacking");
			approachAndAttack(agent);
		} else
		{
			fleeMultipleAgents();
		}		
	}
	private void fleeMultipleAgents() {
		displayMessage("fleeing from multiple agents");
		int min_side = 0, min_number = 0;
		int[] num_agent_side = new int[4];
		num_agent_side[0] = History.getInstance().getCurrentStep().getNumberOfAgents(Constants.DirectionNorth);
		num_agent_side[1] = History.getInstance().getCurrentStep().getNumberOfAgents(Constants.DirectionSouth);
		num_agent_side[2] = History.getInstance().getCurrentStep().getNumberOfAgents(Constants.DirectionEast);
		num_agent_side[3] = History.getInstance().getCurrentStep().getNumberOfAgents(Constants.DirectionWest);
		
		min_number = num_agent_side[0];
		min_side = 0;
		
		for (int i=1; i<4; i++) {
			if (num_agent_side[i]<min_number && canMove(i,1)) {
				min_number = num_agent_side[i];
				min_side = i;
			}
		}
		direction = min_side;
		flee(direction);
		
	}
	private void fleeOneAgent(Point focusPoint) {
		displayMessage("fleeing from one agent");
		if (focusPoint.getX() == -1 && canMove(Constants.DirectionEast,1))
			direction = Constants.DirectionEast;
		else if (focusPoint.getX() == 1 && canMove(Constants.DirectionWest,1))
			direction = Constants.DirectionWest;
		else if (focusPoint.getY() == -1 && canMove(Constants.DirectionNorth,1))
			direction = Constants.DirectionNorth;
		else if (focusPoint.getY() == 1 && canMove(Constants.DirectionSouth,1))
			direction = Constants.DirectionSouth;
		else
			direction = (int)(Math.random()*Constants.Directions.length);
		flee(direction);
		
	}
	private boolean canMove(int direction, int steps) {
		return History.getInstance().getCurrentStep().getLocalMap().canMove(direction,steps);
	}
	private void approachAndEatFood() {
		//Get first food element, which is also the closest food element by default
		Point focusPoint = getSensorFoodList()[0]; 
		Point eatingPosition = getClosestOpenNeighbouringPoint(focusPoint);
		if(eatingPosition != null)
		{
			//Get directions to this element (if possible)
			int[] path = getDirections(eatingPosition);
			if(path != null && path.length > 0)
			{	
				direction = path[0];
				successCount =  1;
				// Heuristic: If food is away, fast approach it
				if (path.length > 4) {
					if (focusPoint.getX() > 0 && focusPoint.getY() > 0)
						if (focusPoint.getX() > focusPoint.getY())
							direction =Constants.DirectionEast;
						else
							direction =Constants.DirectionNorth;
					if (focusPoint.getX() < 0 && focusPoint.getY() < 0)
						if (focusPoint.getX() < focusPoint.getY())
							direction =Constants.DirectionWest;
						else
							direction =Constants.DirectionSouth;
					if (focusPoint.getX() > 0 && focusPoint.getY() < 0)
						if (focusPoint.getX() > Math.abs(focusPoint.getY()))
							direction =Constants.DirectionEast;
						else
							direction =Constants.DirectionSouth;
					if (focusPoint.getX() < 0 && focusPoint.getY() > 0)
						if (Math.abs(focusPoint.getX()) < focusPoint.getY())
							direction =Constants.DirectionNorth;
						else
							direction =Constants.DirectionWest;
					
					move(direction, 4);
				}
				else {
					move(direction, 1);
				}
			}
		}
		if (canEat()) {
			eat();
			eatFailure = 1;			
		}
	}
	private void approachAndAttack(Point agent) {
		int[] path = getDirections(agent);		
		if(path != null && path.length > 0)
		{
			direction = path[0];
			//successCount =  1;
			if (canAttack()) {
				displayMessage("attacking");
				attack(path[0]);
			}
			else {
				displayMessage("moving to attack");
				move(path[0],1);
			}
			
		} else if (canAttack()) {
			attack();
		}

	}
	private double computeDistance(Point agent) {
		double x=0, y=0, distance=0;
		x = agent.getX();
		y = agent.getY();
		distance = Math.sqrt(x*x+y*y);
		return distance;
	}
	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#getName()
	 */
	public String getName() {
		return "ExpertAgent";
	}
	private void displayMessage(String msg) {
		//if (getId() == 0) {
			//System.out.println(msg);
		//}
	}
	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.objects.Agent#getColor()
	 */
	public int[] getColor() {
		int[] rgb = new int[3];
		//if (getId() == 0) {rgb[0] = 0; rgb[1] =0; rgb[2]= 255;}
		//else {rgb[0] = 0; rgb[1] =125; rgb[2]= 123;}
		rgb[0] = 0; rgb[1] =0; rgb[2]= 255;
		return rgb;
	}

}
