
package yaes.application.eel6938.classagents;

import java.awt.Point;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
import java.util.Random;

public class PredatorAgent extends Agent{
    
    Point[] food;
    Point[] obstacles;
    Point[] agents;
    int direction;
    Random r;
    int[][] sensorMap;
    int cx;
    int cy;
    int cz;
    
    /** Creates a new instance of RuleBasedAgent */
    public PredatorAgent() {
        super();
        r = new Random();
        direction = Constants.DirectionNorth;
        cx = r.nextInt(256);
        cy = r.nextInt(256);
        cz = r.nextInt(256);
    }
    
    public void intelligence(){
        food = getSensorFoodList();
        obstacles = getSensorObstacleList();
        agents = getSensorAgentList();
        int i=0;
        int j=0;
        sensorMap = getSensorDataMap();
        
        if(obstacles.length>0){
            do{
                if(isBlocked(15)){
                    direction = r.nextInt(4);
                }else{
                    break;
                }
            }while(i!=300);
        }
        
        move(direction,r.nextInt(4)+1);

        if(food.length!=0){
            moveTowardPoint(food[0],-1);
            eat();
        }
        
        if(agents.length>1){
            if(getName(agents[1])==getName()){
                if(getId(agents[1])<getId(new Point(0,0))){
                    moveTowardPoint(new Point(agents[1].x+7,agents[1].y+7),-1);
                    if(food.length!=0){
                        moveTowardPoint(food[0],-1);
                        eat();
                    }
                }
            }
            for(i=1;i<agents.length;i++){
                if(getName(agents[i])!=getName()){
                    moveTowardPoint(agents[i],4);
                    if(canAttack()){
                        if(agents[i].x==1&&agents[i].y==0){
                            attack(Constants.DirectionEast);
                            break;
                        }
                        if(agents[i].x==0&&agents[i].y==1){
                            attack(Constants.DirectionNorth);
                            break;
                        }
                        if(agents[i].x==0&&agents[i].y==-1){
                            attack(Constants.DirectionSouth);
                            break;
                        }
                        if(agents[i].x==-1&&agents[i].y==0){
                            attack(Constants.DirectionWest);
                            break;
                        }
                    }
                    break;
                }
            }
        }
    }
    
    public String getName(){
        return "PredatorAgent";
    }
    
    public int[] getColor(){
        return new int[]{0,255,0};
        //return new int[]{(cx++)%256,(cy++)%256,(cz++)%256};
    }
    
    private void moveTowardPoint(Point p, int s){
        int speed;
        if(Math.abs(p.x)>Math.abs(p.y)){
            if(!(moveX(p,s))){
                if(!(moveY(p,s))){
                    if(p.y>0){
                        move(Constants.DirectionSouth,4);
                    }else{
                        move(Constants.DirectionNorth,4);
                    }
                }
            }
            
        }else{
            if(!(moveY(p,s))){
                if(!(moveX(p,s))){
                    if(p.x>0){
                        move(Constants.DirectionWest,4);
                    }else{
                        move(Constants.DirectionEast,4);
                    }
                }
            }
        }
    }
    
    private boolean moveX(Point p, int speed){
        int s;
        if(p.x>0){
            direction = Constants.DirectionEast;
            if(isBlocked(Math.abs(p.x))){
                return false;
            }
            s = (Math.abs(p.x/2))+1;
        }else{
            direction = Constants.DirectionWest;
            if(isBlocked(Math.abs(p.x))){
                return false;
            }
            s = (Math.abs(p.x/2))+1;
        }
        if(speed!=-1){
            s = speed;
        }
        move(direction,s);
        return true;
    }
    
    private boolean moveY(Point p, int speed){
        int s;
        if(p.y>0){
            direction = Constants.DirectionNorth;
            if(isBlocked(Math.abs(p.y))){
                return false;
            }
            s = (Math.abs(p.y/2))+1;
        }else{
            direction = Constants.DirectionSouth;
            if(isBlocked(Math.abs(p.y))){
                return false;
            }
            s = (Math.abs(p.y/2))+1;
        }
        if(speed!=-1){
            s = speed;
        }
        move(direction,s);
        return true;
    }
    
    private boolean isBlocked(int d){
        int i;
        if(d>18){
            d=18;
        }
        switch(direction){
            case Constants.DirectionEast:
                d= d+21;
                for(i=21;i<d;i++){
                    if(sensorMap[i][20]==3){
                        return true;
                    }
                }
                break;
            case Constants.DirectionNorth:
                d = 19-d;
                for(i=19;i>d;i--){
                    if(sensorMap[20][i]==3){
                        return true;
                    }
                }
                break;
            case Constants.DirectionSouth:
                d=21+d;
                for(i=21;i<d;i++){
                    if(sensorMap[20][i]==3){
                        return true;
                    }
                }
                break;
            case Constants.DirectionWest:
                d=19-d;
                for(i=19;i>d;i--){
                    if(sensorMap[i][20]==3){
                        return true;
                    }
                }
                break;
        }
        return false;
    }
}
