/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import yaes.application.eel6938.game.objects.Agent;

/**
 * This class represents the AvoidContext
 * @author Viet Trinh
 *
 */
public class AvoidContext extends CxBR_Context 
{
	private static final int MAX_COUNT = 5;
	private int _counter = MAX_COUNT;
	
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public AvoidContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		int speed = CxBR_Map.MAX_SPEED;
		if (this._counter > MAX_COUNT)
			speed = CxBR_Map.MAX_SPEED - 1;
		int direction = this.canAvoid();
		this._map.exploreFlee(this._agent.getSensorDataMap());
		if (this.move(direction, speed) == false)
		{
			direction = this._map.getClearDirection(direction, speed);
			this.move(direction, speed);
		}
	}

	@Override
	public String executeSentinelRules()
	{
		if (this.canAvoid() == -1)
		{
			this._counter = 0;
			return "ExploreContext";
		}
		else
		{
			this._counter++;
			return this._name;
		}
	}
	
	@Override
	public int[] getColor()
	{
		//Yellow
		int[] rgb = new int[3];
		rgb[0]=255; rgb[1]=255; rgb[2]=0; 
		return rgb;
	}
}
