/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import java.awt.Point;

import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
/**
 * This class represents the EatContext
 * @author Viet Trinh
 *
 */
public class EatContext extends CxBR_Context 
{
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public EatContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		Point foodlist[] = this._agent.getSensorFoodList();
		Point food = this._map.getClosestPoint(foodlist);
		this._eat(food);
	}
	
	/**
	 * Use this function to eat a piece of food
	 * @param food The relative point where the food if located
	 * @return true is it eats, false if it is moving towards food
	 */
	protected boolean _eat(Point food)
	{
		int x = food.x;
		int y = food.y;
		
		if      (x == 0  && y == 0)	 { this._agent.eat(); return true; }
		else if (x == 1  && y == 0)  { this._agent.eat(Constants.DirectionEast);  return true; }
		else if (x == -1 && y == 0)  { this._agent.eat(Constants.DirectionWest);  return true; }
		else if (x == 0  && y == 1)  { this._agent.eat(Constants.DirectionNorth); return true; }
		else if (x == 0  && y == -1) { this._agent.eat(Constants.DirectionSouth); return true; }
		else 						 { this._move_towards(food); return false; }
	}
	
	@Override
	public String executeSentinelRules() 
	{
		if (this.canEat())
			return this._name;
		else
			return "ExploreContext";
		/*
		else if (this.canExplore() == true)
			return "ExploreContext";
		else
			return "BackTrackContext";
		*/
	}
	
	
	@Override
	public int[] getColor()
	{
		//Blue
		int[] rgb = new int[3];
		rgb[0]=0; rgb[1]=0; rgb[2]=205; 
		return rgb;
	}
}
