/*
 * Created on Mar 25, 2005
 *
 */
package yaes.application.eel6938.classagents.cxbr;

import java.awt.Point;

import yaes.application.eel6938.classagents.CxBRAgent;
import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.Constants;

/**
 * This class represents the FleeContext
 * @author Viet Trinh
 *
 */
public class FleeContext extends CxBR_Context 
{
	private int _flee_counter = -1;
	private static final int FLEE_CYCLES = 15;
	private static final int MAX_FLEE_CYCLES = Configuration.AgentFleeCycles;
	private int _use_flee_cycles = 9;
	
	private int _total_flee_cycles = 0;
	
	/**
	 * Constructor
	 * @param name Name of the Agent
	 * @param a Agent
	 * @param m Map
	 */
	public FleeContext(String name, Agent a, CxBR_Map m) 
	{
		super(name, a, m);
	}

	@Override
	public void execute() 
	{
		int direction, agent_direction;
		//New Flee Counter
		if (this._flee_counter < 0)
			this._flee_counter = FLEE_CYCLES;
		direction = this.canFlee(this._name);
		this._flee_counter--;
		this._map.exploreFlee(this._agent.getSensorDataMap());
		if (direction == -1)
			direction = this._map.getDirection();
		if (this._agent.canFlee() && (this._flee_counter > this._use_flee_cycles))
		{
				direction = this._map.getClearDirection(direction, CxBR_Map.FLEE_SPEED);
				if (this.flee(direction) == false)
					this.flee(this._map.getClearDirection(this._map.getPerpendicularDirection(direction), CxBR_Map.FLEE_SPEED));
				//this._agent.flee(direction);
				//System.out.println("Fleeing Out of the way");
		}
		else
		{
			//direction = this._map.getDirection();
			direction = this._map.getClearDirection(direction, CxBR_Map.MAX_SPEED);
			this.move(direction, CxBR_Map.MAX_SPEED);
			//System.out.println("Moving Out of the way");
			this._map.getLastMove();
		}
		//System.out.println("Flee Context Direction: " + direction);
		this._map.useMaxSpeed();
	}
	
	@Override
	public String executeSentinelRules() 
	{
		if (this._flee_counter > -1)
			return this._name;
		else if (this.canFlee(this._name) != -1)
			return this._name;
		else if (this.canAvoid() != 1)
			return "AvoidContext";
		else
			return "ExploreContext";
	}
	
	@Override
	public int[] getColor()
	{
		//Very Light Grey
		int[] rgb = new int[3];
		rgb[0]=215; rgb[1]=215; rgb[2]=215; 
		return rgb;
	}
}
