/*
 * FactBase.java
 *
 * Created on March 31, 2005, 11:54 AM
 */

package yaes.application.eel6938.classagents.ruleEngine;

import java.util.ArrayList;
import java.awt.Point;

/**
 *
 * @author johann
 */
public class KnowledgeBase {
    
    ArrayList ruleBase;
    Point[] food;
    Point[] obstacles;
    SensedAgent[] agents;
    boolean[] availableActions;
    int[][] map;
    ArrayList facts;
    public int wanderSpeed, obstacleAvoidance;
    
    /** Creates a new instance of FactBase */
    public KnowledgeBase() {
        facts = new ArrayList();
        ruleBase = new ArrayList();
    }
    
    public void setFacts(Point[] f, Point[] o, SensedAgent[] a, int[][] m, boolean[] acts){
        
        int i;
            
        food = f;
        obstacles = o;
        agents = a;
        map = m;
        availableActions = acts;
        facts = new ArrayList();
        
        for(i=0;i<facts.size();i++){
            facts.remove(i);
        }
    }
    
    public boolean containFact(int f){
        switch (f){
            case RC.AGENTS:
                return (agents.length>1);
            case RC.FOOD:
                return (food.length>0);
        }
        
        if(f<7){
            return availableActions[f];
        }
        return false;
    }
    
    public boolean containFact(String f){
        return facts.contains(f);
    }
    
    public void add(String[] s){
        int i;
        for(i=0;i<s.length;i++){
            add(s[i]);
        }
    }
    
    public void add(String s){
        if(!facts.contains(s)){
            facts.add(s);
        }
    }
    
    public void remove(String s){
        facts.remove(s);
    }
    
    public void addRules(ArrayList r){
        ruleBase = r;
    }
}
