/*
 * Created on Jan 28, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.commands;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.game.objects.Map;
import yaes.application.eel6938.game.objects.ObjectController;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AttackCommand implements ICommandFunction{

	private final int m_X;
	private final int m_Y;
	private final int m_Direction;
	private final Map m_Map;
	
	/**
	 * 
	 */
	public AttackCommand(Map map, int xPos, int yPos, int direction) {
		
		m_Map = map;
		m_X = xPos;
		m_Y = yPos;
		m_Direction = direction;
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.commands.ICommandFunction#commandFunction()
	 */
	public CommandReturn commandFunction() {
		int agentX = m_X;
		int agentY = m_Y;
		
		if(m_Direction == Constants.DirectionNorth)
		{
			agentY -= 1;	
		}
		else if(m_Direction == Constants.DirectionSouth)
		{
			agentY += 1;
		}
		else if(m_Direction == Constants.DirectionWest)
		{
			agentX -= 1;
		}
		else if(m_Direction == Constants.DirectionEast)
		{
			agentX += 1;
		}
		
		//Update energy resources (Increase agent units decrease food units)
		Agent attacker = (Agent)m_Map.getPropertyAt("Agent" , m_X, m_Y);
		Agent subjectToAttack = (Agent)m_Map.getPropertyAt("Agent" , agentX, agentY);
		int attackerDeltaEnergy = 0;
		int attackSubjectDeltaEnergy = 0;
		
		if(subjectToAttack != null && ObjectController.isAlive(subjectToAttack))
		{
			//System.out.println("Attack started!" + attacker.getEnergyLevel() + " vs. " + subjectToAttack.getEnergyLevel());
			//Apply attack procedure!!
			attackerDeltaEnergy = -Configuration.AgentAttackCost;
			attackSubjectDeltaEnergy = -Configuration.AgentAttackedCost;
			
			
			//System.out.println("Attack Deltas!" + attackerDeltaEnergy + " vs. " + attackSubjectDeltaEnergy);
		}
		//Calculate energy values the attck!
		return new CommandReturn(m_X, m_Y, attackerDeltaEnergy, agentX, agentY, attackSubjectDeltaEnergy);
	}

	/* (non-Javadoc)
	 * @see yaes.application.eel6938.game.commands.ICommandFunction#getCommandType()
	 */
	public int getCommandType() {
		// TODO Auto-generated method stub
		return Constants.CommandAttack;
	}

}
