/* 
 * Created on  Apr 7, 2005
 *
 */
package yaes.application.eel6938.game.statistics;
/**
 * @author Linus Luotsinen
 *
 */
public class StatisticsNode {

    private double m_Time;
    private String m_Command;
    private boolean m_LastCommandSuccessful;
    private int m_X;
    private int m_Y;
    private int m_EnergyLevel;
    private boolean m_CanEat;
    private boolean m_CanAttack;
    private boolean m_CanFlee;
    private boolean m_CanMate;
    
    public StatisticsNode(  double time,
                            String command,
                            boolean lastCommandSuccessful,
                            int x,
                            int y,
                            int energyLevel,
                            boolean canEat,
                            boolean canAttack,
                            boolean canFlee,
                            boolean canMate) 
    {
        m_Time = time;
        m_Command = command;
        m_LastCommandSuccessful = lastCommandSuccessful;
        m_X = x;
        m_Y = y;
        m_EnergyLevel = energyLevel;
        m_CanEat = canEat;
        m_CanAttack = canAttack;
        m_CanFlee = canFlee;
        m_CanMate = canMate;
    }
    
    public StatisticsNode( String line ) 
    {
        String[] lineArr = line.split("\t");
        m_Time = Double.parseDouble(lineArr[0]);
        m_Command = lineArr[1];
        m_LastCommandSuccessful = Boolean.parseBoolean(lineArr[2]);
        m_X = Integer.parseInt(lineArr[3]);
        m_Y = Integer.parseInt(lineArr[4]);
        m_EnergyLevel = Integer.parseInt(lineArr[5]);
        m_CanEat = Boolean.parseBoolean(lineArr[6]);
        m_CanAttack = Boolean.parseBoolean(lineArr[7]);
        m_CanFlee = Boolean.parseBoolean(lineArr[8]);
        m_CanMate = Boolean.parseBoolean(lineArr[9]);
    }
    
    public String toString()
    {
        String ret =    m_Time + "\t" + 
                        m_Command + "\t" +
                        m_LastCommandSuccessful + "\t" +
                        m_X + "\t" +
                        m_Y + "\t" +
                        m_EnergyLevel + "\t" +
                        m_CanEat + "\t" +
                        m_CanAttack + "\t" +
                        m_CanFlee + "\t" +
                        m_CanMate;
        return ret;
    }

    public boolean isCanAttack() {
        return m_CanAttack;
    }
    

    public boolean isCanEat() {
        return m_CanEat;
    }
    

    public boolean isCanFlee() {
        return m_CanFlee;
    }
    

    public boolean isCanMate() {
        return m_CanMate;
    }
    

    public String getCommand() {
        return m_Command;
    }
    

    public int getEnergyLevel() {
        return m_EnergyLevel;
    }
    

    public boolean isLastCommandSuccessful() {
        return m_LastCommandSuccessful;
    }
    

    public double getTime() {
        return m_Time;
    }
    

    public int getX() {
        return m_X;
    }
    

    public int getY() {
        return m_Y;
    }
    
}
