/*
 * Created on Feb 14, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.eel6938.game.statistics;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Properties;

import yaes.application.eel6938.game.Configuration;
import yaes.application.eel6938.game.Constants;
import yaes.application.eel6938.game.objects.Agent;
import yaes.application.eel6938.game.objects.ObjectController;
import yaes.framework.world.World;

/**
 * @author Linus Luotsinen, lluotsin@mail.ucf.edu
 * Feb 14, 2005
 * 
 */
public class StatisticsWriter {
	private static String ConfigFileName = "config.cfg";
	private static String LogFileName = "config.log";
	private HashMap <Agent, BufferedWriter>m_FileMap;
	private World m_World;
	private long m_TimeStamp;
	private Properties m_Properties;
	public StatisticsWriter(World world, long startTime, Properties p)
	{
		m_FileMap = new HashMap<Agent, BufferedWriter>();
		//m_Agents = agents;
		m_World = world;
		m_TimeStamp = startTime;//Calendar.getInstance().getTimeInMillis();
		m_Properties = p;
		//saveConfigurationSettings();
		if(Configuration.AppLogAgentData)
        {
			//saveConfigurationSettings(m_Properties);
        }
	}
	
	
	private void saveConfigurationSettings(Properties p)
	{
		File file = new File(Configuration.AppLogPath + m_TimeStamp + "\\");
		file.mkdirs();
		String filePath = 	Configuration.AppLogPath + m_TimeStamp + "\\" + ConfigFileName;
		Configuration.SaveToPropertiesFile(p, filePath);
	}
	
	private void saveConfigurationSettings()
	{
		try 
		{
			String filePath = 	Configuration.AppLogPath + m_TimeStamp + "\\" + LogFileName;
			File file = new File(Configuration.AppLogPath + m_TimeStamp + "\\");
			file.mkdirs();
			BufferedWriter bw = new BufferedWriter(new FileWriter(filePath));
			
			String[] params = Configuration.ToString();
			for(int i=0;i<params.length;i++)
			{
				bw.write(params[i]);
				bw.newLine();
			}
			
			bw.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}
	
	private void removeFileWriter(Agent agent)
	{
		if(agent != null && m_FileMap.containsKey(agent))	//If the agent does not have a file stream yet, create one!
		{
			try 
			{
				BufferedWriter fWriter = (BufferedWriter)m_FileMap.get(agent);
				fWriter.close();
				m_FileMap.remove(agent);
			} 
			catch (IOException e) 
			{
				e.printStackTrace();
			}
		}
	}
	
	private void addFileWriter(Agent agent)
	{
		if(agent != null && !m_FileMap.containsKey(agent))	//If the agent does not have a file stream yet, create one!
		{
			try 
			{
				String filePath = 	Configuration.AppLogPath + m_TimeStamp + "\\" + 
									ObjectController.getAgentId(agent) + "_" + 
                                    agent.getClass().getSimpleName() + ".log";
				File file = new File(Configuration.AppLogPath + m_TimeStamp + "\\");
				file.mkdirs();
				m_FileMap.put(agent, new BufferedWriter(new FileWriter(filePath)));
			} 
			catch (FileNotFoundException e) 
			{
				e.printStackTrace();
			}
			catch (IOException e1) 
			{
				e1.printStackTrace();
			}
		}
	}
	
	private void writeToFile(Agent agent)
	{
		try 
		{
			if(ObjectController.isEnabled(agent) && ObjectController.isAlive(agent))
			{
				BufferedWriter fWriter = (BufferedWriter)m_FileMap.get(agent);
				/*if()
				{
					fWriter.write(	"Cycle" + "\t" + 
							"Command" + "\t" +
							"Successful" + "\t" +
							"X" + "\t" +
							"Y"+ "\t" +
							"Energy" + "\t" +
							"Can Eat" + "\t" +
							"Can Attack" + "\t" +
							"Can Flee" + "\t" +
							"Can Mate"
						);
					fWriter.newLine();
				}*/
				StatisticsNode n = new StatisticsNode(m_World.getTime(),
                        Constants.Commands[agent.getLastCommandType()],
                        agent.wasLastCommandSuccessful(),
                        ObjectController.getX(agent),
                        ObjectController.getY(agent),
                        agent.getEnergyLevel(),
                        agent.canEat(),
                        agent.canAttack(),
                        agent.canFlee(),
                        agent.canMate());
                
				fWriter.write(	n.toString() );
				fWriter.newLine();
			}
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}
	
	
	/*public void refresh()
	{
		Agent[] agents = new Agent[m_Agents.size()];
		m_Agents.toArray(agents);
		for(int i=0; i<agents.length;i++)
		{
			addFileWriter(agents[i]);
			writeToFile(agents[i]);
		}
	}*/
	
	public void refresh(Agent agent)
	{
		addFileWriter(agent);
		writeToFile(agent);	
	}
	
	/*public void flushAgentData()
	{
		Agent[] agents = new Agent[m_Agents.size()];
		m_Agents.toArray(agents);
		for(int i=0; i<agents.length;i++)
		{
			removeFileWriter(agents[i]);
		}
	}*/
	
	public void flushAgentData(Agent agent)
	{
		removeFileWriter(agent);
	}
}
