/* 
 * Created on  Apr 7, 2005
 *
 */
package yaes.application.eel6938.statistics;

import java.util.ArrayList;

import yaes.application.eel6938.game.statistics.IStatistic;
import yaes.application.eel6938.game.statistics.StatisticsNode;
/**
 * @author Linus Luotsinen
 *
 */
public class FailedMoveCommandStatistic implements IStatistic {

    /**
     * 
     */
    public FailedMoveCommandStatistic() {
        super();
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see yaes.application.eel6938.game.statistics.IStatistic#getStatisticValue(yaes.application.eel6938.game.statistics.StatisticsNode[])
     */
    public double[] getStatisticValue(StatisticsNode[] nodes) {
        int failureCntTot = 0;
        int failureCnt = 0;
        double failedMovePenalty = 0;
        ArrayList<Integer> failedMoves = new ArrayList<Integer>();
        
        for(int i=0;i<nodes.length;i++)
        {
            if( nodes[i].getCommand().compareToIgnoreCase("Move")==0 && !nodes[i].isLastCommandSuccessful())
            {
                failureCnt++;
                failureCntTot++;
            }
            else
            {
                if(failureCnt > 0) //Reset and store the sequence in the array
                {
                    //System.out.println("Adding sequence of failures: " + failureCnt);
                    failedMoves.add(new Integer(failureCnt));
                    failedMovePenalty += failureCnt*failureCnt; 
                    failureCnt = 0;
                }
            }
        }
        if(failureCnt > 0) //Reset and store the sequence in the array
        {
           //System.out.println("Adding sequence of failures: " + failureCnt);
            failedMoves.add(new Integer(failureCnt));
            failedMovePenalty += failureCnt*failureCnt; 
            failureCnt = 0;
        }
        
        double[] ret = new double[failedMoves.size()+2];
        ret[0] = failureCntTot;
        ret[1] = failedMovePenalty;
        
        for(int i=0;i<failedMoves.size();i++)
        {
            ret[i+2] = ((Integer)failedMoves.get(i)).intValue();
        }
        return ret;
    }

    /* (non-Javadoc)
     * @see yaes.application.eel6938.game.statistics.IStatistic#getStatisticName()
     */
    public String getStatisticName() {
        return "FailedMoves";
    }

}
