/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner;

import java.util.Iterator;
import java.util.Vector;

import yaes.application.empiricalpathplanner.spline.BSpline;
import yaes.application.empiricalpathplanner.spline.XYZ;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Path 
{	
	private Vector controlPoints;
	private XYZ[] curve;
	private int id;
	private int T;
	private int resolution;
	
	public static int PATHS = 0;
	
	public Path(Vector controlPoints, int T, int resolution)
	{
		this.T = T;
		this.resolution = resolution;
		this.controlPoints = new Vector();
		this.controlPoints = controlPoints;
			
		curve = BSpline.createSpline(T, resolution, getControlPointArray());
		id = PATHS++;
	}
	
	public Path(int T, int resolution)
	{
		this.T = T;
		this.resolution = resolution;
		this.controlPoints = new Vector();
		id = PATHS++;
	}
	
	//	Add two paths. 
	public static Path Add(Path x1, Path x2)
	{
		Path ret = null;
		Vector result = new Vector();
		XYZ[] cX1 = x1.getControlPointArray();
		XYZ[] cX2 = x2.getControlPointArray();
		
		if(cX1.length <= cX2.length)
		{
			
			for(int i=0; i<cX1.length; i++)
			{
				XYZ tmp = new XYZ(0,0,0);
				tmp.x = cX1[i].x + cX2[i].x;
				tmp.y = cX1[i].y + cX2[i].y;
				tmp.z = cX1[i].z + cX2[i].z;
				result.add(tmp);
			}
		}
		else
		{
			for(int i=0; i<cX2.length; i++)
			{
				XYZ tmp = new XYZ(0,0,0);
				tmp.x = cX1[i].x + cX2[i].x;
				tmp.y = cX1[i].y + cX2[i].y;
				tmp.z = cX1[i].z + cX2[i].z;
				result.add(tmp);
			}
		}
		
		ret = new Path(result, 3, 50);
		return ret;
	}
	
	
	//Subtracts two paths. 
	public static Path Subtract(Path x1, Path x2)
	{
		Path ret = null;
		Vector result = new Vector();
		XYZ[] cX1 = x1.getControlPointArray();
		XYZ[] cX2 = x2.getControlPointArray();
		
		if(cX1.length <= cX2.length)
		{
			
			for(int i=0; i<cX1.length; i++)
			{
				XYZ tmp = new XYZ(0,0,0);
				tmp.x = cX1[i].x - cX2[i].x;
				tmp.y = cX1[i].y - cX2[i].y;
				tmp.z = cX1[i].z - cX2[i].z;
				result.add(tmp);
			}
		}
		else
		{
			for(int i=0; i<cX2.length; i++)
			{
				XYZ tmp = new XYZ(0,0,0);
				tmp.x = cX1[i].x - cX2[i].x;
				tmp.y = cX1[i].y - cX2[i].y;
				tmp.z = cX1[i].z - cX2[i].z;
				result.add(tmp);
			}
		}
		
		ret = new Path(result, 3, 50);
		return ret;
	}
	
	//	Multiply paths with constant. 
	public static Path Multiply(Path x1, double r)
	{
		Path ret = null;
		Vector result = new Vector();
		Vector v = x1.getControlPoints();
		Iterator iter = v.iterator();
		
		while(iter.hasNext())
		{
			XYZ control = (XYZ)iter.next();
			XYZ tmp = new XYZ(0,0,0);
			tmp.x = control.x * r;
			tmp.y = control.y * r;
			tmp.z = control.z * r;
			result.add(tmp);
		}
		ret = new Path(result, 3, 50);
		return ret;
	}
	/**
	 * @return Returns the controlPoints.
	 */
	public Vector getControlPoints() {
		return controlPoints;
	}
	
	/**
	 * @return Returns the controlPoints.
	 */
	public XYZ[] getControlPointArray() {
		XYZ[] tmpArr = new XYZ[controlPoints.size()];
		controlPoints.toArray(tmpArr);
		return tmpArr;
	}
	
	/**
	 * @return Returns the curve.
	 */
	public XYZ[] getCurve() {
		return curve;
	}
	
	public String toString()
	{
		String s = "";
		Iterator iter = controlPoints.iterator();
		while(iter.hasNext())
		{
			XYZ p = (XYZ)iter.next();
			s = s + p + " ";
		}
		
		return "PathID: " + id + " " + s;
	}
	
	public void update()
	{
		curve = BSpline.createSpline(T, resolution, getControlPointArray());
	}
	
	public void addControlPoint(XYZ point)
	{
		controlPoints.add(point);
		update();
	}
	
	public void addControlPoint(XYZ point, boolean update)
	{
		controlPoints.add(point);
		if(update)
		{
			update();
		}
	}
	
	public void removeControlPoint(XYZ point)
	{
		controlPoints.remove(point);
		update();
	}
	
	public double getPathLenght()
	{
		double len = 0.0;
		XYZ[] a = getControlPointArray();
		if(a != null && controlPoints.size() >= T)
		{
			for(int i=0; i<a.length-1;i++)
			{
				len += XYZ.distance(a[i],a[i+1]);
			}
		}
		return len;
	}
	
	/**
	 * @return Returns the id.
	 */
	public int getId() {
		return id;
	}
	/**
	 * @return Returns the resolution.
	 */
	public int getResolution() {
		return resolution;
	}
	/**
	 * @return Returns the t.
	 */
	public int getT() {
		return T;
	}
	
	public static Path GenerateRandomPath(	int controlPoints, 
											int T, 
											int resolution,
											int height,
											int width,
											double maxDiffDistance, 
											double minDiffDistance)
	{
		double y = Math.random() * height - 1;
		double x = Math.random() * width - 1;
		Path p = new Path(T, resolution);
		p.addControlPoint(new XYZ(x,y,0), false);
		
		for(int i=0; i<controlPoints-1; i++)
		{
			/*double diffX = (Math.random() * maxDiffDistance - 1) + minDiffDistance;
			double diffY = (Math.random() * maxDiffDistance - 1) + minDiffDistance;
			
			if(Math.round(Math.random() * 1) == 0)
			{
				diffX = -diffX;
			}
			if(Math.round(Math.random() * 1) == 0)
			{
				diffY = -diffY;
			}
			
			y += diffY;
			x += diffX;
			*/
			y = Math.random() * height - 1;
			x = Math.random() * width - 1;
			
			p.addControlPoint(new XYZ(x,y,0), false);
		}
		
		p.update();
		return p;
	}
}
