/*
 * Created on Nov 16, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga;

import yaes.application.empiricalpathplanner.ga.crossover.Crossover;
import yaes.application.empiricalpathplanner.ga.crossover.HeuristicCrossover;
import yaes.application.empiricalpathplanner.ga.crossover.OnePointCrossover;
import yaes.application.empiricalpathplanner.ga.crossover.TwoPointCrossover;
import yaes.application.empiricalpathplanner.ga.crossover.UniformCrossover;
import yaes.application.empiricalpathplanner.ga.mutation.AllPointMutation;
import yaes.application.empiricalpathplanner.ga.mutation.RandomPointMutation;
import yaes.framework.algorithm.geneticalgorithm.ICrossover;
import yaes.framework.algorithm.geneticalgorithm.IFittnessFunction;
import yaes.framework.algorithm.geneticalgorithm.IMutation;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class OperatorFactory {
	//Crossover operators
	public final static int UNIFORM_CROSSOVER = 0;
	public final static int ONEPOINTRANDOM_CROSSOVER = 1;
	public final static int ONEPOINT_CROSSOVER = 2;
	public final static int HEURISTIC_CROSSOVER = 3;
	public final static int TWOPOINT_CROSSOVER = 4;
	
	//Mutation operators
	public final static int ALLPOINT_MUTATION = 0;
	public final static int ONEPOINT_MUTATION = 1;
	
	public static ICrossover CreateCrossoverOperator(int type, PathPlanner pathPlanner)
	{
		IFittnessFunction fitness = pathPlanner.getFittnessFunction();
		ICrossover ret = null;
		switch(type)
		{
			case UNIFORM_CROSSOVER:
			{
				ret = new UniformCrossover();
				break;
			}
			case ONEPOINTRANDOM_CROSSOVER:
			{
				ret = new OnePointCrossover();
				break;
			}
			case ONEPOINT_CROSSOVER:
			{
				ret = new Crossover();
				break;
			}
			case HEURISTIC_CROSSOVER:
			{
				ret = new HeuristicCrossover(fitness);
				break;
			}
			case TWOPOINT_CROSSOVER:
			{
				ret = new TwoPointCrossover(pathPlanner.getKnownChromosomes());
				break;
			}
		}
		return ret;
	}
	
	public static IMutation CreateMutationOperator(int type, Object[] param)
	{
		IMutation ret = null;
		switch(type)
		{
			case ALLPOINT_MUTATION:
			{
				String arg = (String)param[0];
				ret = new AllPointMutation(Integer.parseInt(arg));
				break;
			}
			case ONEPOINT_MUTATION:
			{
				String arg = (String)param[0];
				ret = new RandomPointMutation(Integer.parseInt(arg));
				break;
			}
		}
		return ret;
	}
}
