/*
 * Created on Oct 30, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.ga.crossover;

import java.util.HashSet;
import java.util.Set;

import yaes.application.empiricalpathplanner.Path;
import yaes.application.empiricalpathplanner.ga.Chromosome;
import yaes.application.empiricalpathplanner.spline.XYZ;
import yaes.framework.algorithm.geneticalgorithm.IChromosome;
import yaes.framework.algorithm.geneticalgorithm.ICrossover;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class UniformCrossover implements ICrossover {

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#canMate(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	
	public boolean canMate(IChromosome chromosome1, IChromosome chromosome2) {
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		
		if(a.equals(b))
		{
			//System.out.println("canMate failed: " + a.getChromosomePath().getId() +" == " + b.getChromosomePath().getId());
			return false;
		}
		
		if(a.getChromosomePath().getControlPoints().size() == b.getChromosomePath().getControlPoints().size() 
				&& a.getChromosomePath().getControlPoints().size() > 1 )
		{
			return true;
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#singleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public IChromosome singleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		boolean mask[] = createMask(a.getChromosomePath().getControlPoints().size());
		Path theChild = new Path(3,50);
		for(int i=0;i<mask.length;i++)
		{
			if(mask[i] == true)//Select from a
			{
				XYZ aXYZ = a.getChromosomePath().getControlPointArray()[i];
				theChild.addControlPoint(new XYZ(aXYZ.x, aXYZ.y, aXYZ.z), false);
			}
			else	//select from b
			{
				XYZ bXYZ = b.getChromosomePath().getControlPointArray()[i];
				theChild.addControlPoint(new XYZ(bXYZ.x, bXYZ.y, bXYZ.z), false);
			}
		}
		theChild.update();
		//Add new child
		return new Chromosome(theChild);
		
	}

	/* (non-Javadoc)
	 * @see yaes.framework.algorithm.geneticalgorithm.ICrossover#multipleCrossover(yaes.framework.algorithm.geneticalgorithm.IChromosome, yaes.framework.algorithm.geneticalgorithm.IChromosome)
	 */
	public Set multipleCrossover(IChromosome chromosome1,
			IChromosome chromosome2) {
		Set set = new HashSet();
		Chromosome a = (Chromosome)chromosome1;
		Chromosome b = (Chromosome)chromosome2;
		
		boolean mask[] = createMask(a.getChromosomePath().getControlPoints().size());
		Path theChild1 = new Path(3,50);
		Path theChild2 = new Path(3,50);
		for(int i=0;i<mask.length;i++)
		{
			XYZ aXYZ = a.getChromosomePath().getControlPointArray()[i];
			XYZ bXYZ = b.getChromosomePath().getControlPointArray()[i];
			
			if(mask[i] == true)
			{
				theChild2.addControlPoint(new XYZ(bXYZ.x, bXYZ.y, bXYZ.z), false);
				theChild1.addControlPoint(new XYZ(aXYZ.x, aXYZ.y, aXYZ.z), false);
			}
			else	
			{
				theChild2.addControlPoint(new XYZ(aXYZ.x, aXYZ.y, aXYZ.z), false);
				theChild1.addControlPoint(new XYZ(bXYZ.x, bXYZ.y, bXYZ.z), false);
			}
		}
		theChild1.update();
		theChild2.update();
		//Add new child
		set.add(new Chromosome(theChild1));
		set.add(new Chromosome(theChild2));		
		return set;
	}
	
	public String toString()
	{
		return "Uniform crossover.";
	}
	
	private boolean[] createMask(int maskLenght)
	{
		boolean[] mask = new boolean[maskLenght];
		int numSetTrue = Math.round(maskLenght/2);
		
		for(int i=0; i<numSetTrue; i++)
		{
			int index = (int)Math.floor(maskLenght * Math.random());
			if(mask[index] == false)
			{
				mask[index] = true;
			}
			else
			{
				i--;
			}
		}
		return mask;
	}
}
