/*
 * Created on Nov 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.empiricalpathplanner.testharness;


import java.io.File;
import org.w3c.dom.Document;
import org.w3c.dom.*; 
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 * @author Linus Luotsinen
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Experiments {
	private Experiment[] experiments;
	
	public Experiments(String xmlFile) 
	{
		try {
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse (new File(xmlFile));

			//normalize text representation
			doc.getDocumentElement ().normalize ();
			//System.out.println ("Root element of the doc is " + doc.getDocumentElement().getNodeName());

			NodeList listOfExperiments = doc.getElementsByTagName("experiment");
			int totalExperiments = listOfExperiments.getLength();
			//System.out.println("Total no of experiments : " + totalExperiments); 
			
			//Allocate memory for totalExperiments
			experiments = new Experiment[totalExperiments];
			
			for(int s=0; s<listOfExperiments.getLength() ; s++)
			{
				Node firstExperimentNode = listOfExperiments.item(s);
				if(firstExperimentNode.getNodeType() == Node.ELEMENT_NODE)
				{
					//Experiment information
					Element firstExperimentElement = (Element)firstExperimentNode; 
					String title = firstExperimentElement.getAttribute("title");
					int experimentCount = Integer.parseInt(firstExperimentElement.getAttribute("experiments"));
					//System.out.println("Experiment title: " + title); 
					
					//Map information
					NodeList mapList = firstExperimentElement.getElementsByTagName("map");
					Element mapElement = (Element)mapList.item(0);
					NodeList textMapList = mapElement.getChildNodes();
					String map = ((Node)textMapList.item(0)).getNodeValue().trim();
					//System.out.println("Map: " + map);
					
					
					//Operator information
					NodeList operatorList = firstExperimentElement.getElementsByTagName("operator");
	
					Operator[] operators = new Operator[operatorList.getLength()];
					for(int i=0; i<operatorList.getLength();i++)
					{
						Element operatorElement = (Element)operatorList.item(i);
						int id = Integer.parseInt(operatorElement.getAttribute("id"));
						String type = operatorElement.getAttribute("type");
						
						NodeList argList = operatorElement.getElementsByTagName("arg");
						String []args = new String[argList.getLength()];
						
						//System.out.println("Type: " + type);
						//System.out.println("ID: " + id);
						for(int j=0;j<argList.getLength();j++)
						{
							Element argElement = (Element)argList.item(j);
							args[j]=argElement.getAttribute("value");
							//System.out.println("   ARG: " + args[j]);
						}
						//System.out.println(args.length + " ----");
						operators[i] = new Operator(type, id, args);
					}
					
					
					//System.out.println("Crossover Rate: " + crossoverRate);
					
					
					//Crossover information
					NodeList crossoverrateList = firstExperimentElement.getElementsByTagName("crossoverrate");
					Element crossoverrateElement = (Element)crossoverrateList.item(0);
					NodeList textCRList = crossoverrateElement.getChildNodes();
					float crossoverRate = Float.parseFloat(((Node)textCRList.item(0)).getNodeValue().trim());
					//System.out.println("Crossover Rate: " + crossoverRate);
					
					//Mutation information
					NodeList mutationList = firstExperimentElement.getElementsByTagName("mutationrate");
					Element mutationrateElement = (Element)mutationList.item(0);
					NodeList textMRList = mutationrateElement.getChildNodes();
					float mutationRate = Float.parseFloat(((Node)textMRList.item(0)).getNodeValue().trim());
					//System.out.println("Mutation Rate: " + mutationRate);
					
					//Chromosomes information
					NodeList chromosomesList = firstExperimentElement.getElementsByTagName("chromosomes");
					Element chromosomesElement = (Element)chromosomesList.item(0);
					NodeList textCList = chromosomesElement.getChildNodes();
					int chromosomes = Integer.parseInt(((Node)textCList.item(0)).getNodeValue().trim());
					int chromosomeLength = Integer.parseInt(chromosomesElement.getAttribute("length"));
					int tmpFilter = Integer.parseInt(chromosomesElement.getAttribute("filter"));
					int tmpRandom = Integer.parseInt(chromosomesElement.getAttribute("random"));
					boolean filter = false;
					if(tmpFilter != 0)
						filter = true;
					boolean random = false;
					if(tmpRandom != 0)
						random = true;
					//System.out.println("Chromosomes: " + chromosomes + " Random: " + random + " Filter: " + filter);
					
					//Epoch information
					NodeList epochList = firstExperimentElement.getElementsByTagName("epochs");
					Element epochElement = (Element)epochList.item(0);
					NodeList textEList = epochElement.getChildNodes();
					int epochs = Integer.parseInt(((Node)textEList.item(0)).getNodeValue().trim());
					//System.out.println("Epochs: " + epochs);
					int convergenceCriteria = Integer.parseInt(epochElement.getAttribute("convergencecriteria"));
					if(convergenceCriteria<0)
						convergenceCriteria = 0;
					
					//Find start-goal path information
					NodeList startgoalList = firstExperimentElement.getElementsByTagName("startgoalpath");
					Element startgoalElement = (Element)startgoalList.item(0);
					NodeList textSGList = startgoalElement.getElementsByTagName("point");
					//System.out.println("Number of points: " + textSGList.getLength());
					Point[] points = new Point[textSGList.getLength()];
					for(int i=0; i<textSGList.getLength();i++)
					{
						Element tmpPath = (Element) textSGList.item(i);
						float x = Float.parseFloat(tmpPath.getAttribute("x"));
						float y = Float.parseFloat(tmpPath.getAttribute("y"));
						float z = Float.parseFloat(tmpPath.getAttribute("z"));
						//System.out.println(x + " " + y + " " + z);
						points[i] =  new Point(x,y,z);
					}
					Path startGoalPath = new Path(points);
					
					
					//Find known paths information
					NodeList knownpathsList = firstExperimentElement.getElementsByTagName("knownpaths");
					Element knownpathsElement = (Element)knownpathsList.item(0);
					NodeList textKPList = knownpathsElement.getElementsByTagName("path");
					//System.out.println("Number of paths: " + textKPList.getLength());
					Path[] paths = new Path[textKPList.getLength()];
					for(int i=0; i<textKPList.getLength(); i++)  //Loop through all paths
					{
						Element tmpPath = (Element) textKPList.item(i);
						NodeList textPointList = tmpPath.getElementsByTagName("point");
						//System.out.println("  Number of points: " + textPointList.getLength());
						Point [] tmpPoints = new Point[textPointList.getLength()];
						for(int j=0; j<textPointList.getLength();j++)	//Loop through points
						{
							Element tmpPoint = (Element) textPointList.item(j);
							float x = Float.parseFloat(tmpPoint.getAttribute("x"));
							float y = Float.parseFloat(tmpPoint.getAttribute("y"));
							float z = Float.parseFloat(tmpPoint.getAttribute("z"));
							//System.out.println(x + " " + y + " " + z);
							tmpPoints[j] =  new Point(x,y,z);
						}
						paths[i] = new Path(tmpPoints);	
					}
					KnownPaths knownPaths = new KnownPaths(paths);
					
					
					//Create this experiment
					experiments[s] = new Experiment(title,
													map,
													experimentCount,
													operators,
													crossoverRate, 
													mutationRate, 
													epochs,
													convergenceCriteria,
													chromosomes,
													chromosomeLength,
													random,
													filter,
													startGoalPath,
													knownPaths);
					
				}
			}//end of for loop with s var


			}catch (SAXParseException err) {
			System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
			System.out.println(" " + err.getMessage ());

			}catch (SAXException e) {
			Exception x = e.getException ();
			((x == null) ? e : x).printStackTrace ();

			}catch (Throwable t) {
			t.printStackTrace ();
			}
	}
	
	
	/**
	 * @return Returns the experiments.
	 */
	public Experiment[] getExperiments() {
		return experiments;
	}
}
