/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.gridbrokerage;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author Xin Bai
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Producer {

    double c;

    double left;

    double xi;

    boolean isLinearPrice = true;

    ArrayList consumers = new ArrayList();

    Producer(double c, double xi) {
        this.c = c;
        this.left = c;
        this.xi = xi;
    }

    public void addConsumer(Consumer consumer) {

        if (left <= 0)
            return;

        if (left < consumer.r) {
            consumer.r = left;
        }

        consumers.add(consumer);
        consumer.producer = this;
        consumer.price = getCurrentPrice();
        left -= consumer.r;

    }

    public double getTotalRevenue() {
        double revenue = 0;
        for (Iterator iter = consumers.iterator(); iter.hasNext();) {
            Consumer consumer = (Consumer) iter.next();
            revenue += consumer.r * consumer.duration * consumer.price;
        }
        return revenue;
    }

    public double getCurrentAllocation() {
        if ((c - left) < 0)
            return 0;
        else
            return c - left;
    }

    public double getTotalUsers() {
        return consumers.size();
    }

    public double getCurrentAllocationPercentage() {
        return 1 - left / c;
    }

    public double getTotalUtility() {
        // if ( c==left) return 0;
        if (consumers.size() == 0)
            return 0;
        double utility = 0;
        double r = 0;
        for (Iterator iter = consumers.iterator(); iter.hasNext();) {
            Consumer consumer = (Consumer) iter.next();
            utility += consumer.getUtility() * consumer.r;
            r += consumer.r;
        }
        return utility / r;
    }

    public double getTotalSatisfaction() {
        // if ( c==left) return 0;
        if (consumers.size() == 0)
            return 0;
        double satisfaction = 0;
        double r = 0;
        for (Iterator iter = consumers.iterator(); iter.hasNext();) {
            Consumer consumer = (Consumer) iter.next();
            satisfaction += consumer.getSatisfaction() * consumer.r;
            r += consumer.r;
        }
        return satisfaction / r;
    }

    public double testSatisfaction(Consumer consumer) {
        if (left <= 0) {
            return 0;
        }

        double r;
        if (left >= consumer.r) {
            r = consumer.r;
        } else {
            r = left;
        }

        double utility = consumer.getUtility(r);
        double actualPrice = r * getCurrentPrice();
        double degree = 1 - Math.exp(-consumer.kappa
                * Math.pow(utility, consumer.mu)
                * Math.pow(actualPrice / consumer.phi, -consumer.epsilon));
        return degree;
    }

    public double getCurrentPrice() {
        double currentPrice = xi;

        if (!isLinearPrice) {
            double percent = 1 - left / c;
            if (percent < 0.5) {
                currentPrice = percent * xi + 0.5 * xi;
            } else if (percent > 0.6) {
                currentPrice = 2.5 * percent * xi - 0.5 * xi;
            } else {
                currentPrice = xi;
            }
        }
        return currentPrice;
    }

    public boolean isLinearPrice() {
        return isLinearPrice;
    }

    public void setLinearPrice(boolean isLinearPrice) {
        this.isLinearPrice = isLinearPrice;
    }

}
