package yaes.application.gridbrokerage;



import yaes.ui.plot.PlotLineDescription;

import yaes.framework.simulation.SimulationHelper;

import java.util.ArrayList;

import yaes.framework.simulation.Simulation;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.RandomVariable;

import java.util.List;

import java.io.IOException;

import yaes.framework.simulation.SimulationOutputParameters;

import java.util.Iterator;



/**

 * @author Xin Bai

 * @version 1.0

 */

public class SimulationWithAmount implements Constants {



	public SimulationWithAmount() throws InstantiationException,

			IllegalAccessException, IOException {



		String sValues[] = SVALUE.split(" ");

		int sList[] = new int[sValues.length];

		for (int i = 0; i < sList.length; i++) {

			sList[i] = Integer.parseInt(sValues[i]);

		}



		String uValues[] = UVALUE.split(" ");

		double uList[] = new double[uValues.length];

		for (int i = 0; i < uList.length; i++) {

			uList[i] = Double.parseDouble(uValues[i]);

		}



		// create plots

		ArrayList revenue = new ArrayList();

		ArrayList allocatedResource = new ArrayList();

		ArrayList admittedUsers = new ArrayList();

		ArrayList resourceUtility = new ArrayList();

		ArrayList resourceSatisfaction = new ArrayList();

		ArrayList userUtility = new ArrayList();

		ArrayList userSatisfaction = new ArrayList();

		ArrayList userAdmissionRate = new ArrayList();

		ArrayList allocationBalance = new ArrayList();

		ArrayList allocationPercentageBalance = new ArrayList();

		ArrayList amountOutputs = new ArrayList();



		for (int duration = 50; duration <= 7000; duration = duration + 200) {

			ArrayList inputs = new ArrayList();

			// for (int timeUnit = 100; timeUnit <= 10000; timeUnit = timeUnit +

			// 500) {

			for (int timeUnit = 10000; timeUnit <= 100000; timeUnit = timeUnit + 10000) {

                // timeUnit cannot be zero

				SimulationInputParameters sim = new SimulationInputParameters();

				sim.setParameter(TIMEUNIT, timeUnit);

				sim.setParameter(DURATIONVALUE, duration);

				// sim.setParameter(SATURATIONPERCENTAGE, 100 + duration);

				sim.setStartTime(0);

				sim.setStopTime(5);

				inputs.add(sim);

			}

			// runs the simulation

			List outputs = Simulation

					.simulationSet(inputs, BrokerageSimulation.class,

							BrokerageSimulationContext.class);



			SimulationOutputParameters amountOutput = new SimulationOutputParameters(

					null, null);



			for (int i = 0; i < sList.length; i++) {

				int s = sList[i];



				for (int j = 0; j < uList.length; j++) {

					double u = uList[j];



					String whichLabel;

					String label;



					if (sList.length > 1) {

						whichLabel = Integer.toString(s);

						label = "s-level = " + s;

						if (s == 0) {

							label = "random";

						}

					} else {

						whichLabel = Double.toString(u);

						label = "u-level = " + u;

					}



					// get average value for each time unit

					for (Iterator it = outputs.iterator(); it.hasNext();) {



						amountOutput.update(SATURATIONPERCENTAGE,

								(100 + (float) duration) / 1440);



						SimulationOutputParameters element = (SimulationOutputParameters) it

								.next();

						amountOutput.update(REVENUE + whichLabel, element

								.getValue(REVENUE + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(ALLOCATEDRESOURCE + whichLabel,

								element.getValue(

										ALLOCATEDRESOURCE + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(ADMITTEDUSERS + whichLabel, element

								.getValue(ADMITTEDUSERS + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(RESOURCEUTILITY + whichLabel,

								element.getValue(RESOURCEUTILITY + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(RESOURCESATISFACTION + whichLabel,

								element.getValue(RESOURCESATISFACTION

										+ whichLabel, RandomVariable.TYPE_AVG));

						amountOutput.update(USERUTILITY + whichLabel, element

								.getValue(USERUTILITY + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(USERSATISFACTION + whichLabel,

								element.getValue(USERSATISFACTION + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(USERADMISSIONRATE + whichLabel,

								element.getValue(

										USERADMISSIONRATE + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(ALLOCATIONBALANCE + whichLabel,

								element.getValue(

										ALLOCATIONBALANCE + whichLabel,

										RandomVariable.TYPE_AVG));

						amountOutput.update(ALLOCATIONPERCENTAGEBALANCE

								+ whichLabel, element.getValue(

								ALLOCATIONPERCENTAGEBALANCE + whichLabel,

								RandomVariable.TYPE_AVG));

					}



				}

			}

			amountOutputs.add(amountOutput);

		}



		for (int i = 0; i < sList.length; i++) {

			int s = sList[i];



			for (int j = 0; j < uList.length; j++) {

				double u = uList[j];



				String whichLabel;

				String label;



				if (sList.length > 1) {

					whichLabel = Integer.toString(s);

					label = "s-level = " + s;

					if (s == 0) {

						label = "random";

					}

				} else {

					whichLabel = Double.toString(u);

					label = "u-level = " + u;

				}



				revenue.add(new PlotLineDescription(SATURATIONPERCENTAGE,

						RandomVariable.TYPE_AVG, REVENUE + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				allocatedResource.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						ALLOCATEDRESOURCE + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				admittedUsers.add(new PlotLineDescription(SATURATIONPERCENTAGE,

						RandomVariable.TYPE_AVG, ADMITTEDUSERS + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				resourceUtility.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						RESOURCEUTILITY + whichLabel, RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				resourceSatisfaction.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						RESOURCESATISFACTION + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				userUtility.add(new PlotLineDescription(SATURATIONPERCENTAGE,

						RandomVariable.TYPE_AVG, USERUTILITY + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				userSatisfaction.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						USERSATISFACTION + whichLabel, RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				userAdmissionRate.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						USERADMISSIONRATE + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				allocationBalance.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						ALLOCATIONBALANCE + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));



				allocationPercentageBalance.add(new PlotLineDescription(

						SATURATIONPERCENTAGE, RandomVariable.TYPE_AVG,

						ALLOCATIONPERCENTAGEBALANCE + whichLabel,

						RandomVariable.TYPE_AVG,

						RandomVariable.TYPE_CONFINT_RADIUS, label));

			}

		}



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/Revenue.m", revenue, amountOutputs,

						"", "Saturation Percentage",

						"Average Revenue of Resource Providers Per Unit Time");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/AllocatedResource.m",

						allocatedResource, amountOutputs, "",

						"Saturation Percentage",

						"Average Allocated Resources of Providers (reu)");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/AdmittedUsers.m", admittedUsers,

						amountOutputs, "", "Saturation Percentage",

						"Average Admitted Users of Resource Providers Per Unit Time");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/ResourceUtility.m",

						resourceUtility, amountOutputs, "",

						"Saturation Percentage",

						"Average Resource Utility of Providers");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/ResourceSatisfaction.m",

						resourceSatisfaction, amountOutputs, "",

						"Saturation Percentage",

						"Average Resource Satisfaction of Providers");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/UserUtility.m", userUtility,

						amountOutputs, "", "Saturation Percentage",

						"Average Utility of Users");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/UserSatisfaction.m",

						userSatisfaction, amountOutputs, "",

						"Saturation Percentage",

						"Average Satisfaction of Users");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/UserAdmissionRate.m",

						userAdmissionRate, amountOutputs, "",

						"Saturation Percentage",

						"User Admission Rate of the System");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/AllocationBalance.m",

						allocationBalance, amountOutputs, "",

						"Saturation Percentage",

						"Resource Load Balance Degree of the System");



		SimulationHelper

				.generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(

						"data/gridbrokerage/AllocationPercentageBalance.m",

						allocationPercentageBalance, amountOutputs, "",

						"Saturation Percentage",

						"Resource Load Percentage Balance Degree of the System");



	}

}

