package yaes.application.marketgrid.providers;

import yaes.application.marketgrid.subprotocols.SubProtProviderExecution;
import yaes.application.marketgrid.subprotocols.SubProtProviderPriceQuery;
import yaes.application.marketgrid.subprotocols.SubProtProviderWholeSale;
import yaes.application.marketgrid.subprotocols.SubProtProviderCommited;
import yaes.framework.agent.ExtendedMessage;
import yaes.ui.text.TextUi;

public abstract class ProviderConversation {

    abstract public void action(ExtendedMessage in_message);
    abstract public boolean isFinished();


    public static ProviderConversation getProviderConversationsInstance(
                      MultiProvider provider, ExtendedMessage message) {

       if (message.getValue(SubProtProviderPriceQuery.PARAM_ASKING_PRICE) != null)
          return new ProviderSalesConversations(provider, message,
                   ProviderSalesConversations.ProviderSalesStates.STATE_RETAIL_PRICE_OFFER);

       if (message.getValue(SubProtProviderWholeSale.PARAM_ASKING_PRICE) != null)
          return new ProviderSalesConversations(provider, message,
                   ProviderSalesConversations.ProviderSalesStates.STATE_WHOLESALE_PRICE_OFFER);

       if (message.getSubprotocolMessage().equals(SubProtProviderWholeSale.MSG_SALE_REQUEST))
          return new ProviderSalesConversations(provider, message,
                   ProviderSalesConversations.ProviderSalesStates.STATE_WHOLESALE_SALE_REQUEST);

       if (message.getValue(SubProtProviderCommited.PARAM_REQUESTED_RESOURCES) != null)
          return new ProviderExecuteConversations(provider, message,
          ProviderExecuteConversations.ProviderExecuteStates.STATE_COMMITED_STARTING_EXECUTION);

       if (message.getValue(SubProtProviderExecution.PARAM_REQUESTED_RESOURCES) != null)
          return new ProviderExecuteConversations(provider, message,
          ProviderExecuteConversations.ProviderExecuteStates.STATE_FREE_STARTING_EXECUTION);


      return null;
    }
}
