package yaes.application.marketgrid.resource;



public interface IPricingRule{

  /**
      Describes function of rule element. At present price is defined as quadratic
      function of quantity where every element is optional, thus generating entire family
      of policies from flat to quadratic.
   */
  public enum PricingRuleType{ FLAT, LINEAR, QUADRATIC};
  /*
  public Calendar getStartUsageTime();
  public Calendar getEndUsageTime();
  */
  /** 
      Value of constant for element like A0 or A1 or A2 when describing
      price using quadratic equation

       price = A0 + A1 * Q + A2 * Q^2

      @return constant value for price element
   */
  public double getRuleValue();
  /**
      @return type of rule element defining how the value has to be used (e.g. flat price)
   */
  public PricingRuleType getType();

  /*
  public double getLowerUsageBound();
  public double getUpperUsageBound();
  public Collection<AbstractCommunicatingAgent> getApplicableToUsers();

  public void setStartUsageTime(Calendar time);
  public void setEndUsageTime(Calendar time);
  public void setUnitPrice(double price);
  public void setLowerUsageBound(double quantity);
  public void setUpperUsageBound(double quantity);
  public void setApplicableToUsers(Collection<AbstractCommunicatingAgent> users);
  public void setApplicableToUsers(AbstractCommunicatingAgent user);
  */
}

