/*

 * Created on Sep 28, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.application.taskallocation;



import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;



/**

 * @author Lotzi Boloni

 * 

 * TODO To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Style - Code Templates

 */

public class GridNode implements Constants, Comparable {



    private int id;

    private List upstreamNodes; // upstream nodes

    private List downstreamNodes; // downstream nodes

    private double upstreamWeight[];

    private GridTask currentTask;

    private int finishedTasks;

    private double currentTaskStarted;

    private List receivedTasks;

    private double relativeSpeed;

    private double totalWeight = 1.0;



    public GridNode(int id) {

        this.id = id;

        finishedTasks = 0;

        relativeSpeed = 1.0;

        upstreamNodes = new ArrayList();

        downstreamNodes = new ArrayList();

        receivedTasks = new ArrayList();

        upstreamWeight = new double[5];

        // fixme: this should be exactly the lenght of upstream nodes, and it is not.

        for (int i = 0; i < upstreamWeight.length; i++) {

            upstreamWeight[i] = 0.0;

        }

    }



    public boolean isBusy() {

        return currentTask != null;

    }



    public void receiveUpstreamWeight(GridNode node, double weight,

            SimulationOutputParameters sop) {

        sop.update(MESSAGES, 1);

        int count = 0;

        for (Iterator iter = upstreamNodes.iterator(); iter.hasNext();) {

            GridNode element = (GridNode) iter.next();

            if (element == node) {

                upstreamWeight[count] = weight;

            }

            count++;

        }

    }



    public void receiveTask(GridTask receivedTask) {

        receivedTask.addHop();

        receivedTasks.add(receivedTask);

    }



    public void update(double time, SimulationInputParameters sip,

            SimulationOutputParameters sop) {

        // check the received task list

        // if I am empty: accept a task

        for (Iterator iter = receivedTasks.iterator(); iter.hasNext();) {

            GridTask element = (GridTask) iter.next();

            if (element.getPrewalkNumber() > 0) {

                sendTaskRandomly(element);

                continue;

            }

            if (currentTask == null) {

                //TextUi.println("" + element + " in execution on node "+id);

                //tam.updateAtExecStart(element);

                sop.update(HOPS, element.getHops());

                currentTask = element;

                finishedTasks++;

                currentTaskStarted = time;

                continue;

            }

            int maxHops = sip.getParameterInteger(MAX_HOPS);

            if (element.getHops() > maxHops) {

                // discard the task

                sop.update(DISCARDED, 1);

                continue;

            }

            

            if (sip.getParameterInteger(ALGORITHM) == ALGORITHM_WEIGHTED) {

                sendTask(element);

            } else {

                sendTaskRandomly(element);

            }

        }

        receivedTasks.clear();

        // see if the current task is finished, if yes clean it

        if (currentTask != null) {

            if (time - currentTaskStarted >= currentTask

                    .executionTimeOnMachine(this)) {

                currentTask = null;

            }

        }

        // update the weight and send it to the other nodes

        // FIXME: different formulas are possible here

        if (sip.getParameterInteger(ALGORITHM) == ALGORITHM_WEIGHTED) {

            double newTotalWeight = 0;

            for (int i = 0; i < upstreamNodes.size(); i++) {

                newTotalWeight += upstreamWeight[i];

            }

            newTotalWeight = newTotalWeight / upstreamNodes.size();

            if (currentTask == null) {

                newTotalWeight += 1;

            }

            newTotalWeight = newTotalWeight / 2.0;

            // send the weight downstream

            // FIXME: not always, but it is good for a start

            //if (totalWeight != newTotalWeight) {

            if (Math.abs(totalWeight - newTotalWeight) > 0.1) {

                totalWeight = newTotalWeight;

                for (Iterator iter = downstreamNodes.iterator(); iter.hasNext();) {

                    GridNode element = (GridNode) iter.next();

                    element.receiveUpstreamWeight(this, newTotalWeight, sop);

                }

            }

        }

    }



    private void sendTask(GridTask element) {

        double totalWeight = 0;

        for (int i = 0; i < upstreamWeight.length; i++) {

            totalWeight += upstreamWeight[i];

        }

        if (totalWeight == 0) {

            return;

        }

        // generate the random number in this range, and see where it falls

        double theRandom = Math.random() * totalWeight;

        double currentWeight = 0;

        for (int i = 0; i < upstreamWeight.length; i++) {

            currentWeight += upstreamWeight[i];

            if (theRandom <= currentWeight) {

                GridNode node = (GridNode) upstreamNodes.get(i);

                node.receiveTask(element);

                return;

            }

        }

        //TextUi.println("Something is bad here." + theRandom + " totalWeight "

        // + totalWeight);

    }



    private void sendTaskRandomly(GridTask element) {

        // generate the random number in this range, and see where it falls

        int nextHop = (int) (Math.random() * upstreamWeight.length);

        GridNode node = (GridNode) upstreamNodes.get(nextHop);

        node.receiveTask(element);

    }



    /**

     * @return Returns the downstreamNodes.

     */

    public List getDownstreamNodes() {

        return downstreamNodes;

    }



    /**

     * @return Returns the upstreamNodes.

     */

    public List getUpstreamNodes() {

        return upstreamNodes;

    }



    /**

     * @return Returns the relativeSpeed.

     */

    public double getRelativeSpeed() {

        return relativeSpeed;

    }



    /* (non-Javadoc)

     * @see java.lang.Comparable#compareTo(java.lang.Object)

     */

    public int compareTo(Object arg0) {

        GridNode otherNode = (GridNode) arg0;

        Integer comp = new Integer(finishedTasks);

        Integer comp2 = new Integer(otherNode.finishedTasks);

        return comp.compareTo(comp2);

    }



    /**

     * @return Returns the finishedTasks.

     */

    public int getFinishedTasks() {

        return finishedTasks;

    }

}