package yaes.application.uavaltclient.coalitionformation.ga;



import java.util.Random;



import yaes.framework.algorithm.geneticalgorithm.IChromosome;

import yaes.framework.algorithm.geneticalgorithm.IMutation;



/**

 * Mutation implementation.

 * 

 * @author dejongp

 */

public class MutationImpl implements IMutation

{

	private static Random generator = new Random();

	

  /**

   * Perform a mutation on a chromosome, by randomly altering one bit 

   * (i.e., toggling the presence of one uav in the squadron).

   *

   * @param aChromosome chromosome to mutate

   * @return mutated chromosome

   */

  public IChromosome mutate(IChromosome aChromosome)

  {

		ChromosomeImpl chromosome = (ChromosomeImpl) aChromosome;

		

		boolean[] squadBitmap = chromosome.getSquadBitmap();

	  boolean[] newSquadBitmap = new boolean[squadBitmap.length];

		System.arraycopy(squadBitmap, 0, newSquadBitmap, 0, squadBitmap.length);

		

		int index = generator.nextInt(newSquadBitmap.length);

		if (newSquadBitmap[index])

		  newSquadBitmap[index] = false;

		else

		  newSquadBitmap[index] = true;

			

	  //System.out.println("MUTATION: Old:" + BitmapUtils.toString(squadBitmap) + " New:" + BitmapUtils.toString(newSquadBitmap));

			

	  return new ChromosomeImpl(newSquadBitmap);

  }

}

