/*

 * Created on Nov 28, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.application.ugvteam;



import java.io.IOException;

import java.util.ArrayList;



import yaes.application.ugvteam.agents.AbstractUgvAgent;

import yaes.application.ugvteam.agents.RendezvousAgent;

import yaes.application.ugvteam.agents.SimpleUgvAgent;

import yaes.framework.Version;

import yaes.framework.algorithm.pathplanning.cache.PathCache;

import yaes.framework.entity.control.ControlException;

import yaes.framework.entity.vehicle.ugv.UGV;

import yaes.framework.simulation.RandomVariable;

import yaes.framework.simulation.Simulation;

import yaes.framework.simulation.SimulationHelper;

import yaes.framework.simulation.SimulationInputParameters;

import yaes.framework.simulation.SimulationOutputParameters;

import yaes.framework.world.World;

import yaes.framework.world.map.NamedLocation;

import yaes.framework.world.map.SimpleFreeGround;

import yaes.ui.plot.PlotLineDescription;

import yaes.ui.text.TextUi;

import yaes.ui.visualization.NamedLocationPainter;

import yaes.ui.visualization.VisualMap;



/**

 * @author Lotzi Boloni

 * 

 * To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Generation - Code and Comments

 */

public class Main implements Constants {



	public static void createPoints(UGVContext context) {

		NamedLocationPainter nlp = new NamedLocationPainter();

		NamedLocation src1 = new NamedLocation(20, 24, "SRC1", context.world);

		context.visual.addObject(src1, nlp);

		NamedLocation dst1 = new NamedLocation(230, 243, "DST1", context.world);

		context.visual.addObject(dst1, nlp);

		NamedLocation src2 = new NamedLocation(200, 100, "SRC2", context.world);

		context.visual.addObject(src2, nlp);

		NamedLocation dst2 = new NamedLocation(10, 180, "DST2", context.world);

		context.visual.addObject(dst2, nlp);

		NamedLocation src3 = new NamedLocation(252, 120, "SRC3", context.world);

		context.visual.addObject(src3, nlp);

		NamedLocation dst3 = new NamedLocation(35, 200, "DST3", context.world);

		context.visual.addObject(dst3, nlp);

		// UGV sources and destinations

		NamedLocation src_ugv1 = new NamedLocation(150, 60, "SRCU1",

				context.world);

		context.visual.addObject(src_ugv1, nlp);

		NamedLocation dst_ugv1 = new NamedLocation(10, 170, "DSTU1",

				context.world);

		context.visual.addObject(dst_ugv1, nlp);

		NamedLocation dst_ugv1_var = new NamedLocation(10, 240, "DSTU1_VAR",

				context.world);

		context.visual.addObject(dst_ugv1_var, nlp);

		NamedLocation src_ugv2 = new NamedLocation(189, 115, "SRCU2",

				context.world);

		context.visual.addObject(src_ugv2, nlp);

		NamedLocation dst_ugv2 = new NamedLocation(25, 220, "DSTU2",

				context.world);

		context.visual.addObject(dst_ugv2, nlp);

		NamedLocation mp1 = new NamedLocation(149, 122, "MP1", context.world);

		context.visual.addObject(mp1, nlp);

		NamedLocation mp2 = new NamedLocation(43, 34, "MP2", context.world);

		context.visual.addObject(mp2, nlp);

	}



	public static void simulate(World world, VisualMap visual)

			throws ControlException, InterruptedException {

		visual.repaint();

		int count = 0;

		for (double time = 0.0; time < 1000; time = time + 1) {

		}

		visual.repaint();

	}



	public static void scenario4(UGVContext context) {

		UGVTeamHelper.createConvoy("First", "SRC1", "DST1", context, 0);

		UGVTeamHelper.createConvoy("Second", "SRC2", "DST2", context, 0);

		UGVTeamHelper.createConvoy("Third", "SRC3", "DST3", context, 0);

		UGVTeamHelper.createRendezvousUgv("SRCU1", "DSTU1_VAR", context);

	}



	public static void scenario5(UGVContext context) {

		UGVTeamHelper.createConvoy("First", "SRC1", "DST1", context, 0);

		UGVTeamHelper.createConvoy("Second", "SRC2", "DST2", context, 0);

		UGVTeamHelper.createConvoy("Third", "SRC3", "DST3", context, 0);

		UGVTeamHelper.createRendezvousUgv("SRCU1", "DSTU1", context);

	}



	public static void scenario6(UGVContext context) {

		UGVTeamHelper.createConvoy("First", "SRC1", "DST1", context, Math.random() * 100);

		UGVTeamHelper.createConvoy("Second", "SRC2", "DST2", context, Math.random() * 100);

		UGVTeamHelper.createConvoy("Third", "SRC3", "DST3", context, Math.random() * 100);

		UGV ugv1 = UGVTeamHelper.createRendezvousUgv("SRCU1", "DSTU1", context);

		context.ugvAgent[0] = (RendezvousAgent) ugv1.getAgent();

		UGVTeamHelper.createRendezvousUgv("SRCU2", "DSTU2", context);

		UGV ugv2 = UGVTeamHelper.createSimpleUgv("SRCU1", "DSTU1", context);

		context.ugvAgent[1] = (SimpleUgvAgent) ugv2.getAgent();

		UGVTeamHelper.createRendezvousUgv("SRCU2", "DSTU2", context);

		UGV ugv3 = UGVTeamHelper.createSimpleUgv("SRCU1", "DSTU1", context);

		context.ugvAgent[2] = (AbstractUgvAgent) ugv3.getAgent();

		UGVTeamHelper.createRendezvousUgv("SRCU2", "DSTU2", context);

	}



	public static void main2(String args[]) throws InterruptedException,

			ControlException, InstantiationException, IllegalAccessException {

		TextUi.println(Version.versionString());



		PathCache.initPathCache();

		SimulationInputParameters sim = new SimulationInputParameters();

		sim.setStartTime(0);

		sim.setStopTime(5000);

		sim.setParameter(VISUALIZE, VISUALIZE_YES);

		UGVContext context = new UGVContext(3);

		context.world = new World();

		context.visual = new VisualMap();

		SimpleFreeGround ground = new SimpleFreeGround();

		context.world.setMap(ground);

		ground.loadImage("data/ugvteams/scenario3/scenario4.png");

		context.visual.addObject(ground);

		createPoints(context);

		scenario6(context);

		SimulationOutputParameters sop = Simulation.simulate(sim,

				UGVSimulationCode.class, context);

		PathCache.flush();

		TextUi.println("" + sop);

		System.exit(0);

	}



	public static void main(String args[]) throws InterruptedException,

			ControlException, InstantiationException, IllegalAccessException, IOException {

		TextUi.println(Version.versionString());



		PathCache.initPathCache();

		ArrayList outputs = new ArrayList();

		for (int i = 0; i != 20; i++) {			

			SimulationInputParameters sim = new SimulationInputParameters();

			sim.setStartTime(0);

			sim.setStopTime(5000);

			sim.setParameter(VISUALIZE, VISUALIZE_NO);

			sim.setParameter("COUNT", i);

			UGVContext context = new UGVContext(3);

			context.world = new World();

			context.visual = new VisualMap();

			SimpleFreeGround ground = new SimpleFreeGround();

			context.world.setMap(ground);

			ground.loadImage("data/ugvteams/scenario3/scenario4.png");

			context.visual.addObject(ground);

			createPoints(context);

			scenario6(context);

			SimulationOutputParameters sop = Simulation.simulate(sim,

					UGVSimulationCode.class, context);

			outputs.add(sop);

		}

		PathCache.flush();

		ArrayList list = new ArrayList();

		list.add(new PlotLineDescription("COUNT",

				RandomVariable.TYPE_AVG, TIME_TO_REACH_DESTINATION + "_0",

				RandomVariable.TYPE_AVG, "Rendezvous"));

		list.add(new PlotLineDescription("COUNT",

				RandomVariable.TYPE_AVG, TIME_TO_REACH_DESTINATION + "_1",

				RandomVariable.TYPE_MAX, "Simple"));

		list.add(new PlotLineDescription("COUNT",

				RandomVariable.TYPE_AVG, TIME_TO_REACH_DESTINATION + "_2",

				RandomVariable.TYPE_MAX, "Eager"));

		SimulationHelper.generatePlotFromPlotDescriptionList("data/taskallocation/hops.m", list, outputs);

		System.exit(0);

	}



}