/*
 * Created on Nov 6, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.application.ugvteam;

import java.awt.Color;

import yaes.application.ugvteam.agents.AbstractUgvAgent;
import yaes.application.ugvteam.agents.EagerJoinerAgent;
import yaes.application.ugvteam.agents.RendezvousAgent;
import yaes.application.ugvteam.agents.SimpleUgvAgent;
import yaes.framework.algorithm.pathplanning.cache.PathCache;
import yaes.framework.entity.control.speedcontrol.PathFollowControl;
import yaes.framework.entity.vehicle.ugv.UGV;
import yaes.framework.world.World;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.NamedLocation;
import yaes.framework.world.map.PlannedPath;
import yaes.ui.visualization.IPainter;
import yaes.ui.visualization.MovingObjectPainter;
import yaes.ui.visualization.PathPainter;
import yaes.ui.visualization.VisualMap;

/**
 * @author lboloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class UGVTeamHelper {

	public static UGV createUgvWithPath(String sourceName,
			String destinationName, VisualMap visual, World world) {
		NamedLocation source = world.getNamedLocation(sourceName);
		NamedLocation destination = world.getNamedLocation(destinationName);
		return createUgvWithPath(source, destination, visual, world);
	}

	public static UGV createUgvWithPath(Location src, Location dst,
			VisualMap visual, World world) {
		UGV theUgv = new UGV(1, world.getMap());
		world.getVehicles().add(theUgv);
		theUgv.setLocation(src);
		PlannedPath path = new PlannedPath();
		path.setSource(src);
		path.setDestination(dst);
		PathCache.findPath(path, world.getMap(), true);
		PathPainter pp = new PathPainter();
		pp.setColor(Color.YELLOW);
		visual.addObject(path, pp);
		theUgv.setCurrentPath(path);
		PathFollowControl control = new PathFollowControl(path);
		theUgv.setControl(control);
		return theUgv;
	}

	public static UGVConvoy createConvoy(String name, String sourceName,
			String destinationName, UGVContext context, double startTime) {
		NamedLocation source = context.world.getNamedLocation(sourceName);
		NamedLocation destination = context.world
				.getNamedLocation(destinationName);
		return createConvoy(name, source, destination, context.world,
				context.visual, startTime);
	}

	public static UGVConvoy createConvoy(String name, Location source,
			Location destination, World world, VisualMap vm, double startTime) {
		UGV leader = new UGV(0, world.getMap());
		// the convoy is doing a simple path following with a delayed start
		SimpleUgvAgent theAgent = new SimpleUgvAgent(leader, world, destination);
		theAgent.whiteIsAccessible = false;
		theAgent.setStartTime(startTime);
		leader.setAgent(theAgent);		
		leader.setLocation(source);
		UGVConvoy convoy = new UGVConvoy(name, source, destination);
		world.getVehicles().add(leader);
		world.getConvoys().add(convoy);
		convoy.join(leader.getAgent());
		convoy.setLeader(leader.getAgent());
		//leader.setControl(convoy.getLeaderStrategy(world, vm));
		vm.addObject(leader);
		return convoy;
	}

	public static UGV createRendezvousUgv(String source, String destination,
			UGVContext context) {
		UGV theUgv1 = createUgvWithPath(source, destination, context.visual,
				context.world);
		IPainter painter = new MovingObjectPainter(true, Color.blue);
		context.visual.addObject(theUgv1, painter);
		RendezvousAgent agent = new RendezvousAgent(theUgv1, context.world, context.world
				.getNamedLocation(destination));
		theUgv1.setAgent(agent);
		theUgv1.startPathRecording();
		return theUgv1;
	}

	/**
	 * @param string
	 * @param string2
	 * @param context
	 * @return
	 */
	public static UGV createSimpleUgv(String source, String destination,
			UGVContext context) {
		UGV theUgv1 = createUgvWithPath(source, destination, context.visual,
				context.world);
		IPainter painter = new MovingObjectPainter(true, Color.yellow);
		context.visual.addObject(theUgv1, painter);
		SimpleUgvAgent agent = new SimpleUgvAgent(theUgv1, context.world, context.world
				.getNamedLocation(destination));
		theUgv1.setAgent(agent);
		theUgv1.startPathRecording();
		return theUgv1;
	}

	public static UGV createEagerJoinerUgv(String source, String destination,
			UGVContext context) {
		UGV theUgv1 = createUgvWithPath(source, destination, context.visual,
				context.world);
		IPainter painter = new MovingObjectPainter(true, Color.yellow);
		context.visual.addObject(theUgv1, painter);
		AbstractUgvAgent agent = new EagerJoinerAgent(theUgv1, context.world ,context.world
				.getNamedLocation(destination));
		theUgv1.setAgent(agent);
		theUgv1.startPathRecording();
		return theUgv1;
	}

}