/*

 * Created on Nov 8, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.framework.agent;



import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;



import yaes.framework.world.World;



/**

 * @author Lotzi Boloni

 *

 * TODO To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

public abstract class AbstractCommunicatingAgent implements ICommunicatingAgent {



	private String name;

	protected World world;

	

	protected List<IMessage> receivedMessages = new ArrayList<IMessage>();

	

	/**

	 * @param name

	 */

	public AbstractCommunicatingAgent(String name, World world) {

		super();

		this.name = name;

		this.world = world;

	}

	/* (non-Javadoc)

	 * @see yaes.framework.agent.ICommunicatingAgent#receiveMessage(yaes.framework.agent.IMessage)

	 */

	public void receiveMessage(IMessage message) {

		receivedMessages.add(message);

	}

	

	public String getName() {

		return name;

	}

    

    public IMessage getReceivedMessage() {

        if (receivedMessages.isEmpty()) return null;

        IMessage message = receivedMessages.iterator().next();

        receivedMessages.remove(message);

        return message;

    }



    public ExtendedMessage getExtendedMessage() {

        for (Iterator<IMessage> iter = receivedMessages.iterator(); iter.hasNext();) {

            IMessage element = iter.next();

            if (element instanceof ExtendedMessage) {

                receivedMessages.remove(element);

                return (ExtendedMessage) element;

            }

        }

        return null;

    }

    

	/**

	 * Returns from the queue an extended message which is part of a conversation or 

	 * null if no message arrived. 

	 * @param id

	 * @return

	 */

    public ExtendedMessage getExtendedMessageFromConversation(String id) {

        for (IMessage element: receivedMessages) {

            if (element instanceof ExtendedMessage) {

				ExtendedMessage msg = (ExtendedMessage) element;

				if (id.equals(msg.getConversation())) {

					receivedMessages.remove(element);

					return msg;

				}

            }

        }

        return null;

    }

    

	public void send(IMessage message) {

		world.getDirectory().deliverMessage(message);

	}

	

}

