/*

 * Created on Sep 21, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.algorithm.pathplanning;



import java.util.ArrayList;

import java.util.Collections;

import java.util.Iterator;

import java.util.List;

import yaes.framework.algorithm.search.AbstractTreeSearch;

import yaes.framework.algorithm.search.IClosedNodes;

import yaes.framework.algorithm.search.TreeSearchNode;

import yaes.framework.world.map.GrayIsAccessible;

import yaes.framework.world.map.IAccessibilityChecker;

import yaes.framework.world.map.IMap;

import yaes.framework.world.map.Location;

import yaes.framework.world.map.MapHelper;

import yaes.framework.world.map.PathLength;

import yaes.framework.world.map.PlannedPath;

import yaes.ui.text.TextUi;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public abstract class AbstractTreePathPlanner extends AbstractTreeSearch  implements IPathPlanner {

    

    private Location destination;

    private IMap theMap;

    protected PlannedPath thePath;

    private IAccessibilityChecker accessibilityChecker;

    // this would make it a graph searcher

    IClosedNodes closed;

    

    /**

     * @param problemDescription

     * @param problemSpace

     */

    public AbstractTreePathPlanner(PlannedPath problemDescription, IMap problemSpace) {

        super(problemDescription, problemSpace);

        theMap = problemSpace;

        thePath = problemDescription;

        destination = problemDescription.getDestination();

        accessibilityChecker = new GrayIsAccessible();

    }



    

    protected abstract void initFringe();

    

    protected void initializeSearchTree(Object problemDescription, Object problemSpace) {

        initFringe();

        if (this instanceof AStarPP) {

           closed = new AStarClosedNodeSet(new PathLength(), (AStarFringe)theFringe);

        }

        TreeSearchNode init = new TreeSearchNode(null, thePath.getSource());

        theFringe.addNode(init);

    }

    

    

    protected boolean isSolution(TreeSearchNode node) {

        Location current = (Location) node.getObject();

        if (current.equals(destination)) {

            return true;

        }

        return false;

    }

    

    protected void expandNode(TreeSearchNode node) {

        Location current = (Location) node.getObject();        

        List neighbors = MapHelper.getNeighbors(theMap, current);

        for (Iterator iter = neighbors.iterator(); iter.hasNext();) {

            Location element = (Location) iter.next();

            if (accessibilityChecker.isAccessible(theMap, element) == false) {

            	continue;

            }

            TreeSearchNode node2 = new TreeSearchNode(node, element);

            if (closed == null || !closed.alreadyExpanded(node2)) {

               getFringe().addNode(node2);

            }

        }

        if (closed != null) {

           closed.setAlreadyExpanded(node);

        }

    }

    

    private static Object staticReadOutSolution(TreeSearchNode node) {

        ArrayList l = new ArrayList();

        TreeSearchNode current = node;

        while (current != null) {

            l.add(current.getObject());

            current = current.getParent();

        }

        Collections.reverse(l);

        return l;

    }

    

    

    protected Object readOutSolution(TreeSearchNode node) {

        return staticReadOutSolution(node);

    }



    /* (non-Javadoc)

     * @see simulation.algorithms.IPathPlanner#planPath(simulation.environment.maps.PlannedPath, simulation.environment.maps.IMap)

     */

    public boolean planPath(PlannedPath path, IMap map) {

        List l = (List)search(); 

        if (l == null) {

            TextUi.println("No path found");

            return false;

        }

        System.out.println("Solution found");

        for (Iterator iter = l.iterator(); iter.hasNext();) {

            Location element = (Location) iter.next();

            path.addLocation(element);

            //System.out.println(element);

        }



        return false;

    }

	/**

	 * @return Returns the accessibilityChecker.

	 */

	public IAccessibilityChecker getAccessibilityChecker() {

		return accessibilityChecker;

	}

	/**

	 * @param accessibilityChecker The accessibilityChecker to set.

	 */

	public void setAccessibilityChecker(

			IAccessibilityChecker accessibilityChecker) {

		this.accessibilityChecker = accessibilityChecker;

	}

}

