/*

 * Created on Sep 12, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.algorithm.routing.wca;



import java.util.HashSet;

import java.util.Iterator;

import java.util.Set;



import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.sensornetwork.SensorNetwork;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class ConnectivityCalculation2 {

    

    private SensorNetwork n;

    private Set componentRepresentatives; // the clusterheads which are the representatives of the components

    private Set alreadyUsedClusterHeads; // these are  

    

    

    public ConnectivityCalculation2(SensorNetwork n) {

        this.n = n;

    }



    public double calculateConnectivity() {

        double connectivity = (double) componentCalculation()

                / (double) n.nodeInfoList.size();        

        return connectivity;

    }

    

    /**

     * Compute the neighbors of the clusterhead, those which are other clusterheads.

     *

     */

    private void computeCHNeighbor() {

        int i, j;

        double distance;

        int noNodes;

        for (Iterator iter = n.clusterHeadSet.iterator(); iter.hasNext();) {

            ClusterHead sourceNode = (ClusterHead) iter.next();

            for (Iterator it2 = n.clusterHeadSet.iterator(); it2.hasNext();) {

                ClusterHead destNode = (ClusterHead) it2.next();

                if (sourceNode == destNode) {

                    continue;

                }

                distance = sourceNode.getTheNode()

                        .distance(destNode.getTheNode());

                //System.out.println("\nDistance: " + distance + "CH_TX_RANGE : "

                //       + Constants.CH_TX_RANGE);

                //   ... if the distance is within the transmission txRange

                //   ... then destNode is neighbor of the sourceNode, and VS.

                // FIXME: this is probably needs to be CH_TX_RANGE !!!

                // yeah, normally, with the normal TX range, you should find it 0. 

                double txRange = sourceNode.getTheNode().getChTxRange();

                if (distance <= txRange) {

                    sourceNode.clusterNeighborList.add(destNode);

                }

            }

        }

    }    

    

    public int componentCalculation() {

        computeCHNeighbor();

        alreadyUsedClusterHeads = new HashSet();

        componentRepresentatives = new HashSet();

        int maxComponentSize = 0;

        int totalComponentSize = 0;

        for (Iterator iter = n.clusterHeadSet.iterator(); iter.hasNext();) {

            ClusterHead ch = (ClusterHead) iter.next();

            // already used            

            if (alreadyUsedClusterHeads.contains(ch)) {

                continue;

            }

            componentRepresentatives.add(ch);

            // it is the representative of a new connected component!!!

            int componentSize = parseComponent(ch);

            totalComponentSize += componentSize;

            if (componentSize > maxComponentSize) {

                maxComponentSize = componentSize;

            }

        }

        // check if totalComponentSize is the size of the network

        if (totalComponentSize != n.nodeInfoList.size()) {

            System.out.println("No of nodes: " + n.nodeInfoList.size() + " total components:" + totalComponentSize);

        }

        // System.out.println("( " + componentRepresentatives.size() + " / " + n.clusterHeadSet.size() + " ) components / clusters");

        return maxComponentSize;

    }



    /**

     * Starting from the clusterhead ch, it goes breath first and loads all the 

     * clusterheads which are neighbors of the original. 

     * Then, for all those clusterheads loads the neighbors of the regular nodes, 

     * and counts them. 

     * 

     * @param ch

     * @return

     */

    private int parseComponent(ClusterHead ch) {

        int componentSize = 0;

        Set clusterHeadsOfTheComponent = new HashSet();

        Set frontier = new HashSet();        

        frontier.add(ch);

        // now I need to breadth first seach on this

        while(frontier.size() > 0) {

            ClusterHead toAdd = (ClusterHead)frontier.iterator().next();

            clusterHeadsOfTheComponent.add(toAdd);

            componentSize += toAdd.clusterContentSize() + 1;

            frontier.remove(toAdd);

            // now iterate over its neighbors

            for (Iterator iter = toAdd.clusterNeighborList.iterator(); iter.hasNext();) {

                ClusterHead element = (ClusterHead) iter.next();

                if (clusterHeadsOfTheComponent.contains(element)) {

                    continue;

                }

                frontier.add(element);

            }

        }

        for (Iterator iter = clusterHeadsOfTheComponent.iterator(); iter.hasNext();) {

            ClusterHead element = (ClusterHead) iter.next();

            alreadyUsedClusterHeads.add(element);

            

        }

        return componentSize;

    }

    

}

