/*
 * Created on Sep 17, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.algorithm.search;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;

import yaes.framework.algorithm.pathplanning.IPathPlanner;
import yaes.framework.world.map.IMap;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.MapConstants;
import yaes.framework.world.map.MapHelper;
import yaes.framework.world.map.PlannedPath;

/**
 * @author lboloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class NonRecBestFirstSearch implements IPathPlanner {

    IMap theMap;

    List currentPath;

    Stack frontier;

    /*
     * (non-Javadoc)
     * 
     * @see simulation.algorithms.IPathPlanner#planPath(simulation.environment.maps.PlannedPath,
     *      simulation.environment.maps.IMap)
     */
    public boolean planPath(PlannedPath path, IMap map) {
        theMap = map;
        currentPath = path.getLocationList();
        solve(path.getSource(), path.getDestination());
        return false;
    }

    List findNeighbors(Location currentPosition, Comparator comparator) {
        List neighbors = MapHelper.getNeighbors(theMap, currentPosition);

        List acceptableNeighbors = new ArrayList();
        for (Iterator iter = neighbors.iterator(); iter.hasNext();) {
            Location n = (Location) iter.next();
            // loop avoidance
            if (currentPath.contains(n)) {
                continue;
            }
            // accessible points in the map
            if (theMap.getPropertyAtAsBoolean(MapConstants.ACCESSIBLE, n) == false) {
                continue;
            }
            acceptableNeighbors.add(n);
        }
        // sort the acceptableNeighbors
        Collections.sort(acceptableNeighbors, comparator);
        return acceptableNeighbors;
    }

    List solve(Location source, Location destination) {
        Location currentPosition = source;
        Comparator comparator = new DestinationComparator(destination);
        frontier.push(currentPosition);
        while (true) {
            // currentPosition = frontier.pop();
            if (MapHelper.distance(currentPosition, destination) == 0.0) { return currentPath; }
            // generate the neighbors of the current position
            List acceptableNeighbors = findNeighbors(currentPosition,
                    comparator);
            // call solve recursively for all of them.
            for (Iterator iter = acceptableNeighbors.iterator(); iter.hasNext();) {
                Location n = (Location) iter.next();
                currentPath.add(n);
                List s = solve(n, destination);
                
                if (s != null) { return currentPath; }
                currentPath.remove(n);
            }
            return null;
        }
    }

}