/*

 * Created on Sep 26, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.algorithm.search;



import java.util.Comparator;



import yaes.framework.world.map.Location;





/**

 * @author Lotzi Boloni

 *

 * This class compares two treenodes, but delegates its comparison to an embedded comparator

 */

public class TreeNodeComparator implements Comparator {



    private Comparator embedded;



    public TreeNodeComparator() {

        super();

        this.embedded = null;

    }    

    /**

     * @param embedded

     */

    public TreeNodeComparator(Comparator embedded) {

        super();

        this.embedded = embedded;

    }

    

    /* (non-Javadoc)

     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)

     */

    public int compare(Object arg0, Object arg1) {

        if (arg0.equals(arg1)) {

            return 0;

        }

        TreeSearchNode tsn0 = (TreeSearchNode) arg0;

        TreeSearchNode tsn1 = (TreeSearchNode) arg1;

        // default: based on the tmp value

        if (embedded == null) {

            return Double.compare(tsn0.tmp, tsn1.tmp); 

        }

        

        int value = embedded.compare(tsn0.getObject(),tsn1.getObject());

        if (value == 0) {

            Location l0 = (Location) tsn0.getObject();

            Location l1 = (Location) tsn1.getObject();

            if (l0.getX() > l1.getX()) {

                return 1;

            } else if (l0.getX() < l1.getX()) {

                return -1;

            } else if (l0.getY() > l1.getY()) {

                return 1;

            } else {

                return 0;

            }

        }

        return value;

    }

}

