/*
 * Created on Aug 30, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.entity.vehicle;

import yaes.framework.entity.control.ControlException;
import yaes.framework.entity.control.IAccelerationControl;
import yaes.framework.entity.control.IAccelerationControllable;
import yaes.framework.entity.control.IControl;
import yaes.framework.entity.control.ILocationControl;
import yaes.framework.entity.control.ILocationControllable;
import yaes.framework.entity.control.ISpeedControl;
import yaes.framework.entity.control.ISpeedControllable;
import yaes.framework.world.map.Acceleration;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.Path;
import yaes.framework.world.map.Speed;

/**
 * @author lboloni
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Vehicle
        implements
            IMovingObject,
            IPathRecorder,
            ILocationControllable,
            ISpeedControllable,
            IAccelerationControllable {

    protected int vehicleId;
    protected int coalitionId;
    protected IControl control;
    protected Location location;
    protected Speed speed;
    protected Speed lastSpeed, speedHighLimit, speedLowLimit;
    protected Speed originalSpeed;
    protected Acceleration acceleration;
    private Path path;

    public Vehicle(int vehicleId) {
        this.vehicleId = vehicleId;
    }

    // public abstract void update(AbstractSimulation simulation);
    public int getId() {
        return this.vehicleId;
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getAcceleration()
     */
    public Acceleration getAcceleration() {
        return acceleration;
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getLocation()
     */
    public Location getLocation() {
        return location;
    }

    /* (non-Javadoc)
     * @see simulation.vehicles.IMovingObject#getSpeed()
     */
    public Speed getSpeed() {
        return speed;
    }

    public synchronized void setLocation(Location location) {
        this.location = location;
        if (pathRecording) {
            path.addLocation(location);
        }
    }

    public void setControl(IControl control) {
        this.control = control;
        if (control instanceof ILocationControl) {
            ((ILocationControl) control).setControllable(this);
        }
        if (control instanceof ISpeedControl) {
            ((ISpeedControl) control).setControllable(this);
        }
        if (control instanceof IAccelerationControl) {
            ((IAccelerationControl) control).setControllable(this);
        }
    }

    /* (non-Javadoc)
     * @see simulation.control.IAccelerationControllable#controlAcceleration(simulation.environment.maps.Acceleration)
     */
    public void controlAcceleration(Acceleration acceleration)
            throws ControlException {
        this.acceleration = acceleration;
    }

    /* (non-Javadoc)
     * @see simulation.control.ILocationControllable#controlLocation(simulation.environment.maps.Location)
     */
    public void controlLocation(Location location) throws ControlException {
        this.location = location;
    }

    /* (non-Javadoc)
     * @see simulation.control.ISpeedControllable#controlSpeed(simulation.environment.maps.Speed)
     */
    public void controlSpeed(Speed speed) {
        this.speed = speed;
    }

    private boolean pathRecording = false;

    public synchronized void startPathRecording() {
        path = new Path();
        pathRecording = true;
        path.addLocation(location);
    }

    public synchronized void stopPathRecording() {
        path = null;
        pathRecording = false;
    }

    public synchronized Path getRecordedPath() {
        return path;
    }

    public IControl getControl() {
        return control;
    }

    public int getCoalitionId() {
        return this.coalitionId;
    }

    public void setCoalitionId(int cid) {
        this.coalitionId = cid;
    }

    public Speed getLastSpeed() {
        return this.lastSpeed;
    }

    public void setLastSpeed(Speed aspeed) {
        this.lastSpeed = aspeed;
    }

    public Speed getOriginalSpeed() {
        return this.originalSpeed;
    }
}
