/*

 * Created on Oct 5, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.framework.simulation;



import java.util.ArrayList;

import java.util.Iterator;

import java.util.List;



import yaes.ui.text.TextUi;



/**

 * @author Lotzi Boloni

 *

 * TODO To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

public class Simulation {



	public static SimulationOutputParameters simulate(

			SimulationInputParameters sim, Class simulationCode,

			Class contextClass) throws InstantiationException,

			IllegalAccessException {

		IContext context = (IContext) contextClass.newInstance();

		return simulate(sim, simulationCode, context);

	}	

	

	public static SimulationOutputParameters simulate(

			SimulationInputParameters sim, Class simulationCode,

			IContext context) throws InstantiationException,

			IllegalAccessException {

		ISimulationCode code = (ISimulationCode) simulationCode.newInstance();

		SimulationOutputParameters sop = new SimulationOutputParameters(sim, context);		

		long start = System.currentTimeMillis();

		TextUi.println("Starting simulation: " + code);

		TextUi.println("Input parameters: " + sim);

		code.setup(sim, context);

		for (double time = sim.getStartTime(); time < sim.getStopTime(); time = time

				+ sim.getTimeResolution()) {

			code.update(time, sim, sop, context);

		}

		code.postprocess(sim, sop, context);

		TextUi.println("Simulation time: " + ((int)((System.currentTimeMillis() - start) / 1000) ) + " seconds");

		return sop;

	}



	public static List simulationSet(List sipList, Class simulationCode,

			Class contextClass) throws InstantiationException,

			IllegalAccessException {

		long start = System.currentTimeMillis();

		List sopList = new ArrayList();

		int count = 0;

		for (Iterator iter = sipList.iterator(); iter.hasNext();) {

			TextUi.println("\nSimulation step: (" + (count++) + " / " + sipList.size() + ")");

			SimulationInputParameters element = (SimulationInputParameters) iter

					.next();

			SimulationOutputParameters sop = simulate(element, simulationCode,

					contextClass);

			sopList.add(sop);

		}

		TextUi.println("Total simulation time: " + ((int)((System.currentTimeMillis() - start) / 1000) ) + " seconds");

		return sopList;

	}

}

