/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.simulation;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import yaes.ui.plot.PlotLineDescription;
import yaes.ui.plot.SimulationPlot;

/**
 * @author Lotzi Boloni
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SimulationHelper {

  public static void generatePlotFromPlotDescriptionList(String fileName,
      List<PlotLineDescription> descriptionList, List outputs) throws IOException {
    SimulationPlot plot = new SimulationPlot();
    for (PlotLineDescription pld : descriptionList) {
      ArrayList xValues = new ArrayList();
      ArrayList yValues = new ArrayList();
      for (Iterator it2 = outputs.iterator(); it2.hasNext(); ) {
        SimulationOutputParameters element = (SimulationOutputParameters) it2
            .next();
        if (pld.contains(element)) {
          xValues
              .add(new Double(element.getValue(pld.getXVarName(),
                                               pld.getXVarType())));
          yValues
              .add(new Double(element.getValue(pld.getYVarName(),
                                               pld.getYVarType())));
        }
      }
      plot.addOnePlot(pld.getYVarLabel(), yValues, "-");
      plot.setXPoints(xValues);
    }
    plot.generateMatlabPlotFileWithLegend(fileName);
  }

  // This function is created by Xin on Feb 14, 2005
  public static void generatePlotFromPlotDescriptionListWithTitleLabel(String
      fileName,
      List descriptionList, List outputs, String title, String xLabel,
      String yLabel) throws IOException {
    SimulationPlot plot = new SimulationPlot();
    for (Iterator iter = descriptionList.iterator(); iter.hasNext(); ) {
      PlotLineDescription pld = (PlotLineDescription) iter.next();
      ArrayList xValues = new ArrayList();
      ArrayList yValues = new ArrayList();
      for (Iterator it2 = outputs.iterator(); it2.hasNext(); ) {
        SimulationOutputParameters element = (SimulationOutputParameters) it2
            .next();
        if (pld.contains(element)) {
          xValues
              .add(new Double(element.getValue(pld.getXVarName(),
                                               pld.getXVarType())));
          yValues
              .add(new Double(element.getValue(pld.getYVarName(),
                                               pld.getYVarType())));
        }
      }
      plot.addOnePlot(pld.getYVarLabel(), yValues, "-");
      plot.setXPoints(xValues);
    }
    plot.generateMatlabPlotFileWithTitleLabelLegend(fileName, title, xLabel,
        yLabel);
  }

  // This function is created by Xin on Feb 14, 2005
  public static void generateErrorBarPlotFromPlotDescriptionListWithTitleLabel(
      String fileName,
      List descriptionList, List outputs, String title, String xLabel,
      String yLabel) throws IOException {

    SimulationPlot plot = new SimulationPlot();
    for (Iterator iter = descriptionList.iterator(); iter.hasNext(); ) {
      PlotLineDescription pld = (PlotLineDescription) iter.next();
      ArrayList xValues = new ArrayList();
      ArrayList yValues = new ArrayList();
      ArrayList yRadiusValues = new ArrayList();
      for (Iterator it2 = outputs.iterator(); it2.hasNext(); ) {
        SimulationOutputParameters element = (SimulationOutputParameters) it2
            .next();
        if (pld.contains(element)) {
          xValues
              .add(new Double(element.getValue(pld.getXVarName(),
                                               pld.getXVarType())));
          yValues
              .add(new Double(element.getValue(pld.getYVarName(),
                                               pld.getYVarType())));
          yRadiusValues
              .add(new Double(element.getValue(pld.getYVarName(),
                                               pld.getYRadiusVarType())));
        }
      }
      plot.addOneErrorBarPlot(pld.getYVarLabel(), yValues, yRadiusValues, "-");
      plot.setXPoints(xValues);
    }
    plot.generateMatlabErrorBarPlotFileWithTitleLabelLegend(fileName, title, xLabel,
        yLabel);
  }

  public static void generatePlotFromSimulationResults(String fileName,
      List list, String xCoord, int xType, String yCoord, int yType,
      String yLabel) throws IOException {
    ArrayList xValues = new ArrayList();
    ArrayList yValues = new ArrayList();
    for (Iterator iter = list.iterator(); iter.hasNext(); ) {
      SimulationOutputParameters element = (SimulationOutputParameters) iter
          .next();
      xValues.add(new Double(element.getValue(xCoord, xType)));
      yValues.add(new Double(element.getValue(yCoord, yType)));
    }
    SimulationPlot plot = new SimulationPlot();
    plot.addOnePlot(yLabel, yValues, "-");
    plot.setXPoints(xValues);
    plot.generateMatlabPlotFileWithLegend(fileName);
  }
}
