/*

 * Created on Sep 30, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.framework.simulation;



import java.util.ArrayList;

import java.util.HashMap;

import java.util.Iterator;

import java.util.List;



/**

 * @author Lotzi Boloni

 *

 * TODO To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

public class SimulationOutputParameters {

	HashMap variables = new HashMap();

	private IContext theContext;

	

    /**

     * @return Returns the theContext.

     */

    public IContext getTheContext() {

        return theContext;

    }



    public SimulationOutputParameters(SimulationInputParameters sim, IContext context) {

        if (sim != null) {

		   sim.moveParametersToOutput(this);

        }

		this.theContext = context;

	}

	

	public RandomVariable createVariable(String name) {

		RandomVariable var = new RandomVariable(name);

		variables.put(name, var);

		return var;

	}

	

	public void update(String name, double value) {

		RandomVariable var = (RandomVariable) variables.get(name);

		if (var == null) {

			var = createVariable(name);

		}

		var.update(value);		

	}

	

	public double getAvg(String name) {

		RandomVariable var = (RandomVariable) variables.get(name);

		return var.getAvg();

	}

	

	public double getSum(String name) {

		RandomVariable var = (RandomVariable) variables.get(name);

		return var.getSum();

	}

	

	public int getCount(String name) {

		RandomVariable var = (RandomVariable) variables.get(name);

		return var.getCount();

	}

	

	public double getValue(String name, int type) {

		RandomVariable var = (RandomVariable) variables.get(name);

		if (var == null) {

			throw new Error("Can not find variable:" + name);

		}

		return var.getValue(type);		

	}

	

	public RandomVariable getRandomVar(String name) {

		RandomVariable var = (RandomVariable) variables.get(name);

		if (var == null) {

			throw new Error("Random variable:" + name + " not found!");

		}

		return var;

	}

	

	public List getRandomVariableNames() {

		ArrayList list = new ArrayList();

		for (Iterator iter = variables.keySet().iterator(); iter.hasNext();) {

			String key = (String) iter.next();

			list.add(key);

		}

		return list;		

	}

	

	public String toString() {

		StringBuffer buffer = new StringBuffer("");

		for (Iterator iter = variables.keySet().iterator(); iter.hasNext();) {

			String key = (String) iter.next();

			RandomVariable rv = getRandomVar(key);

			buffer.append(rv.toString());			

		}

		return buffer.toString();

	}

}



