/*

 * Created on Sep 9, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.world.map;



import java.util.ArrayList;

import java.util.List;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class MapHelper {

    

    public static List getNeighbors(IMap map, Location location) {

        List neighbors = new ArrayList();

        double x = location.getX();

        double y = location.getY();

        double dx = map.getXPreferredStep();

        double dy = map.getYPreferredStep();

        Location tent = new Location(x+dx, y-dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x, y-dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x+dx, y-dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x-dx, y);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x+dx, y);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x-dx, y+dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x, y+dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        tent = new Location(x+dx, y+dy);

        if (contains(map, tent)) {

            neighbors.add(tent);

        }

        return neighbors;

    }

    

    public static boolean contains(IMap map, Location location) {

        double x = location.getX();

        double y = location.getY();

        if (map.getXLow() > x) {

            return false;

        }

        if (map.getYLow() > y) {

            return false;

        }

        if (map.getXHigh() <= x) {

            return false;

        }

        if (map.getYHigh() <= y) {

            return false;

        }

        return true;

    }

    

    public static double distance(Location a, Location b) {

        return Math.sqrt((a.getX() - b.getX())*(a.getX() - b.getX()) + (a.getY() - b.getY())*(a.getY() - b.getY()));

    }



	/**

	 * Returns the closest integer subscript location, which is accepted by the

	 * checked.   

	 * FIXME: this is not quite the closest, but it returns consistent results...

	 * 

	 * @param loc

	 * @param checker

	 * @param map

	 * @return

	 */

	public static Location getRoundedLocation(Location loc,

			IAccessibilityChecker checker, IMap map) {

		Location result_loc = loc.getRoundedLocation();

		if (checker.isAccessible(map, result_loc)) {

			return result_loc;

		}

		result_loc = new Location(result_loc.getX(), result_loc.getY() + 1);

		if (checker.isAccessible(map, result_loc)) {

			return result_loc;

		}

		result_loc = new Location(result_loc.getX(), result_loc.getY() - 1);

		if (checker.isAccessible(map, result_loc)) {

			return result_loc;

		}

		result_loc = new Location(result_loc.getX() + 1, result_loc.getY());

		if (checker.isAccessible(map, result_loc)) {

			return result_loc;

		}

		result_loc = new Location(result_loc.getX() - 1, result_loc.getY());

		if (checker.isAccessible(map, result_loc)) {

			return result_loc;

		}

		System.out.println("No safe location found for:" + loc);

		return loc.getRoundedLocation();

	}

    

    

}

