/*

 * Created on Sep 25, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.world.map;



import java.util.Iterator;



import yaes.framework.algorithm.search.TreeSearchNode;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class PathLength extends AbstractPathCost {



    /* (non-Javadoc)

     * @see simulation.environment.maps.AbstractPathCost#cost(simulation.environment.maps.Path)

     */

    public double cost(Path path) {

        Location previous = null;

        double cost = 0.0;

        for (Iterator iter = path.getLocationList().iterator(); iter.hasNext();) {

            Location currentLocation = (Location) iter.next();

            if (previous != null) {

                cost += MapHelper.distance(currentLocation, previous);

            }

            previous = currentLocation;

        }

        //cost = path.getLocationList().size();

        return cost;

    }



    public double cost(Path path, Location startLoc, Location endLoc) {

        Location previous = null;

        double cost = 0.0;

        boolean startCost = false;



        for (Iterator iter = path.getLocationList().iterator(); iter.hasNext();) {

            Location currentLocation = (Location) iter.next();

            if (!startCost && previous != null && startLoc.locationWithIn(previous,currentLocation)) {

              startCost = true;

            }

            if (startCost) {

                cost += MapHelper.distance(currentLocation, previous);

            }

            if (previous != null && endLoc.locationWithIn(previous,currentLocation)) {

              startCost = false;

              break;

            }

            previous = currentLocation;

        }

        //cost = path.getLocationList().size();

        return cost;

    }



    /* (non-Javadoc)

     * @see simulation.environment.maps.AbstractPathCost#cost(simulation.algorithms.treesearch.TreeSearchNode)

     */

    public double cost(TreeSearchNode node) {

        TreeSearchNode currentNode = node;

        Location previous = null;

        double cost = 0.0;

        while (true) {

            Location currentLocation = (Location) currentNode.getObject();

            if (previous != null) {

                cost += MapHelper.distance(currentLocation, previous);

            }

            previous = currentLocation;

            currentNode = currentNode.getParent();

            if (currentNode == null) {

                return cost;

            }

        }

    }

}

