/*

 * Created on Dec 13, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.world.network.node.energymodel;



import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.sensornetwork.SensorNode;

import yaes.ui.text.TextUi;





/**

 * @author Lotzi Boloni

 *

 * To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

public class AdvancedSensorEnergyModel extends AbstractEnergyModel {

    

	private double computationPower;

	private double transmissionCoefficient;

	private double transmissionRate = 0.1;

	

    public AdvancedSensorEnergyModel(SensorNode theNode, double computationPower, double transmissionCoefficient) {

    	super(theNode);

    }    



    /* (non-Javadoc)

     * @see yaes.framework.world.network.node.energymodel.IEnergyModel#updateEnergy(double)

     */

    public double updateEnergy(double time) {

        double currentPower = 0;

        double elapsedTime = time - lastTime;

        lastTime = time;

       	// the linear component, for computation

        currentEnergy = currentEnergy - computationPower * elapsedTime;

    	// the transmission component

        if (theNode.getClusterHead() == null) {

        	updateTransmissionForRegularNode(elapsedTime);

        } else {

        	updateTransmissionForClusterHead(elapsedTime);

        }

        return currentEnergy;

    }



	/**

	 * @param elapsedTime

	 */

	private void updateTransmissionForClusterHead(double elapsedTime) {

		double d = theNode.getChTxRange(); // FIXME clusterHeadAdvantage;

		ClusterHead ch = theNode.getClusterHead();

		int clusterMembers = ch.clusterContentSize();

		currentEnergy = currentEnergy - clusterMembers * transmissionRate * transmissionCoefficient * Math.pow(d,4);

	}



	/**

	 * @param elapsedTime

	 */

	private void updateTransmissionForRegularNode(double elapsedTime) {

		// double d = theNode.getTxRange(); // FIXME distance from the clusterhead!

		ClusterHead masterCH = theNode.getMasterClusterHead();

		if (masterCH == null) {

			TextUi.println("This node is not member of any cluster!");

			return;

		}

		double d = theNode.distance(masterCH.getTheNode());

		currentEnergy = currentEnergy - transmissionRate * transmissionCoefficient * Math.pow(d, 4);

	}

}

