/*

 * Created on Sep 13, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.world.network.sensornetwork;



import java.util.Iterator;



import yaes.framework.algorithm.routing.wca.Constants;

import yaes.framework.world.network.node.energymodel.SensorEnergyModel;









/**

 * @author Lotzi B?l?ni

 * 

 * To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Generation - Code and Comments

 */

public class SensorNetworkHelper {



    public static void changeNodeCoordinate(SensorNetwork n, double time,

            int maxDisplacement) {

        for (Iterator iter = n.nodeInfoList.iterator(); iter.hasNext();) {

            SensorNode scan = (SensorNode) iter.next();

            int newxcord = generateCoordinateWithRandomMovement(

                    scan.getXcord(), maxDisplacement);

            //   ... get the old y_coordinate and generate the new y_coordinate

            int newycord = generateCoordinateWithRandomMovement(

                    scan.getYcord(), maxDisplacement);

            //scan.computeDistanceMovement(newxcord, newycord);

            //    ... compute mobility

            //scan.computeMobility(time, newxcord, newycord);

            //   ... set the xCoor with new xCoor

            //scan.setXcord(newxcord);

            //   ... set the yCoor with new yCoor

            //scan.setYcord(newycord);

            scan.setNewPosition(time, newxcord, newycord);

        }

    }



    private static int generateRandomCoordinate() {

        int coordinate;

        //   ... return a number an txRange 0 to 100

        coordinate = 1 + (int) (Math.random() * Constants.GRID);

        return coordinate;

    }



    private static int generateCoordinateWithRandomMovement(int oldCoor,

            int maxDisplacement) {

        boolean randomDirection;

        int delta, newCoor;

        //   ... this loop will continue until we get a new coor

        //   ... within [0..GRID]

        while (true) {

            if (Math.random() < 0.5) {

                randomDirection = true;

            } else {

                randomDirection = false;

            }

            //   ... generate an integer value between 0..maxDisplacement

            Math.random();

            delta = (int) (Math.random() * maxDisplacement);

            //   ... For the new coordinate

            //   ... oldCoor = oldCoor +( -) delta

            //   ... randomDirection has a value 0 or 1

            //   ... We assume that randomDirection == 1 -> +

            //   ... and randomDirection == 0 --> -

            if (randomDirection)

                newCoor = oldCoor + delta;

            else

                newCoor = oldCoor - delta;

            //   ... if we get a newCoor within [0..GRID] then we stop

            if ((newCoor > 0) && (newCoor < Constants.GRID)) break;

        }

        return (newCoor);

    }



    /**

     * 

     * This generates a new, homogeneous network with nodeCount nodes randomly

     * distributed in the network. It will also generate the nodes such that

     * they will have maximum power.

     * 

     * @param nodeCount

     * @param txRange

     */

    static public void generateRandomNetwork(SensorNetwork n, int nodeCount,

            int txRange) {

        for (int i = 0; i < nodeCount; i++) {

            //   ... generates the xCoor and yCoor

            int xCoorIn = generateRandomCoordinate();

            int yCoorIn = generateRandomCoordinate();

            //System.out.println("\nNodeId: " + (i + 1) + " xCoor: " + xCoorIn

            //        + " yCoor: " + yCoorIn);

            //   ... create a new node with xCoorIn, and yCoorIn

            //   ... other values set to 0 by default

            SensorNode newNodeInfo = new SensorNode(i + 1, 0, xCoorIn, yCoorIn);

            newNodeInfo.setTxRange(txRange);

            newNodeInfo.setEnergyModel(new SensorEnergyModel(newNodeInfo, 0.1, 1.0));

            n.nodeInfoList.add(newNodeInfo);

        }

    }





}