/*

 * Created on Sep 4, 2004

 *

 * To change the template for this generated file go to

 * Window - Preferences - Java - Code Generation - Code and Comments

 */

package yaes.framework.world.network.sensornetwork;



import java.util.ArrayList;

import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.node.NodeWithPosition;

import yaes.framework.world.network.node.energymodel.IEnergyModel;



/**

 * @author Lotzi Boloni

 * 

 * To change the template for this generated type comment go to Window -

 * Preferences - Java - Code Generation - Code and Comments

 */

public class SensorNode extends NodeWithPosition {



	private static final double CH_ADVANTAGE	 = 2.0;

	

    private int id;

    private int nodeWeight;

    private boolean mark;

    private int degree;

    private ClusterHead clusterHead; /* whether cluster head or not */

    private ClusterHead masterClusterHead; // the clusterhead to which this node, as a regular node is member of

    private double accumulateWeight;

    private double mobility;

    private double totalCHTime;

    private double distanceMovement;

    private int txRange;

    private IEnergyModel energyModel;

    private double energy;

    public ArrayList neighborList = new ArrayList();

    public ArrayList chDistanceList = new ArrayList(); // distances in time from

    // the clusterhead - for

    // the scheduling

    // algorithms

    public boolean failed = false;



    /**

     * @return Returns the energyModel.

     */

    public IEnergyModel getEnergyModel() {

        return energyModel;

    }



    /**

     * @param energyModel

     *            The energyModel to set.

     */

    public void setEnergyModel(IEnergyModel energyModel) {

        this.energyModel = energyModel;

    }



    /**

     * @return Returns the txRange.

     */

    public double getTxRange() {

        return txRange;

    }



    public double getChTxRange() {

    	return txRange * CH_ADVANTAGE;

    }

    

    /**

     * @param txRange

     *            The txRange to set.

     */

    public void setTxRange(int txRange) {

        this.txRange = txRange;

    }



    /**

     * @param id

     * @param nodeWeight

     * @param xcord

     * @param ycord

     * @param mark

     * @param degree

     * @param isClusterHead

     * @param clusterHeadId

     * @param accumulateWeight

     */

    public SensorNode(int id, int nodeWeight, int xcord, int ycord) {

        super(xcord, ycord);

        this.id = id;

        this.nodeWeight = nodeWeight;

        this.degree = 0;

        this.clusterHead = null;

        // default values

        this.accumulateWeight = 0.0;

        this.mark = false;

        this.mobility = 0.0;

    }



    /**

     * @return Returns the accumulateWeight.

     */

    public double getAccumulateWeight() {

        return accumulateWeight;

    }



    /**

     * @param accumulateWeight

     *            The accumulateWeight to set.

     */

    public void setAccumulateWeight(double accumulateWeight) {

        this.accumulateWeight = accumulateWeight;

    }



    /**

     * @return Returns the isClusterHead.

     */

    public ClusterHead getClusterHead() {

        return clusterHead;

    }



    /**

     * @param isClusterHead

     *            The isClusterHead to set.

     */

    public void setClusterHead(ClusterHead clusterHead) {

        this.clusterHead = clusterHead;

    }



    /**

     * @return Returns the mark.

     */

    public boolean getMark() {

        return mark;

    }



    /**

     * @param mark

     *            The mark to set.

     */

    public void setMark(boolean mark) {

        this.mark = mark;

    }





    /**

     * @return Returns the degree.

     */

    public int getDegree() {

        return degree;

    }



    /**

     * @return Returns the distanceMovement.

     */

    public double getDistanceMovement() {

        return distanceMovement;

    }



    /**

     * @return Returns the id.

     */

    public int getId() {

        return id;

    }



    /**

     * @return Returns the mobility.

     */

    public double getMobility() {

        return mobility;

    }



    /**

     * @return Returns the neighborList.

     */

    public ArrayList getNeighborList() {

        return neighborList;

    }



    /**

     * @return Returns the nodeWeight.

     */

    public int getNodeWeight() {

        return nodeWeight;

    }



    /**

     * @return Returns the totalCHTime.

     */

    public double getTotalCHTime() {

        return totalCHTime;

    }



    /**

     * @param degree

     *            The degree to set.

     */

    public void setDegree(int degree) {

        this.degree = degree;

    }



    /**

     * @param nodeWeight

     *            The nodeWeight to set.

     */

    public void setNodeWeight(int nodeWeight) {

        this.nodeWeight = nodeWeight;

    }



    /**

     * @param d

     */

    public void setTotalCHTime(double totalCHTime) {

        this.totalCHTime = totalCHTime;

    }



    /**

     * @param newxcord

     * @param newycord

     */

    public void setNewPosition(double time, int newxcord, int newycord) {

        if (time == 0.0) {

            return;

        }

        distanceMovement = Math.sqrt((newxcord - getXcord())

                * (newxcord - getXcord()) + (newycord - getYcord())

                * (newycord - getYcord()));        

        mobility = ((time - 1) * mobility + distanceMovement) / time;

        setXcord(newxcord);

        setYcord(newycord);

    }

	/**

	 * @return Returns the masterClusterHead.

	 */

	public ClusterHead getMasterClusterHead() {

		return masterClusterHead;

	}

	/**

	 * @param masterClusterHead The masterClusterHead to set.

	 */

	public void setMasterClusterHead(ClusterHead masterClusterHead) {

		this.masterClusterHead = masterClusterHead;

	}

}