
package yaes.ui.plot;

import yaes.framework.simulation.SimulationOutputParameters;

/**
 * @author Lotzi Boloni
 *
 *  This class describes a plot line
 */
public class PlotLineDescription {

	private String xVarName;
	private int xVarType;
	private String yVarName;
	private int yVarType;
        private int yRadiusVarType; // added by Xin on Feb 14, 2005
	private String yVarLabel;

	private IPlotLineFilter plotLineFilter;

	/**
	 * @param varName
	 * @param varType
	 * @param varName2
	 * @param varType2
	 */
	public PlotLineDescription(String varName, int varType, String varName2,
			int varType2, String yVarLabel) {
		super();
		xVarName = varName;
		xVarType = varType;
		yVarName = varName2;
		yVarType = varType2;
		this.yVarLabel = yVarLabel;
	}

        // This function is created by Xin on Feb 14, 2005
        public PlotLineDescription(String varName, int varType, String varName2,
                        int varType2, int varType3, String yVarLabel) {
                super();
                xVarName = varName;
                xVarType = varType;
                yVarName = varName2;
                yVarType = varType2;
                yRadiusVarType = varType3;
                this.yVarLabel = yVarLabel;
        }

	/**
	 * @return Returns the xVarName.
	 */
	public String getXVarName() {
		return xVarName;
	}
	/**
	 * @return Returns the xVarType.
	 */
	public int getXVarType() {
		return xVarType;
	}
	/**
	 * @return Returns the yVarName.
	 */
	public String getYVarName() {
		return yVarName;
	}
	/**
	 * @return Returns the yVarType.
	 */
	public int getYVarType() {
		return yVarType;
	}
        public int getYRadiusVarType() {
                return yRadiusVarType;
        }
	/**
	 * @return
	 */
	public String getYVarLabel() {
          return yVarLabel;
	}
    /**
     * @return Returns the plotLineFilter.
     */
    public IPlotLineFilter getPlotLineFilter() {
        return plotLineFilter;
    }
    /**
     * @param plotLineFilter The plotLineFilter to set.
     */
    public void setPlotLineFilter(IPlotLineFilter plotLineFilter) {
        this.plotLineFilter = plotLineFilter;
    }
    /**
     * @param element
     * @return
     */
    public boolean contains(SimulationOutputParameters element) {
        if (plotLineFilter == null) {
            return true;
        }
        return plotLineFilter.considerThisResult(element);
    }
}
