/*
 * Created on Sep 15, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.ui.visualization;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.util.Iterator;
import yaes.framework.entity.vehicle.IMovingObject;
import yaes.framework.entity.vehicle.IPathRecorder;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.Path;

/**
 * @author lboloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class MovingObjectPainter implements IPainter {

	private boolean fill;

	private Color color;

	private boolean paintPath;

	private PathPainter thePathPainter = null;

	public MovingObjectPainter() {
		this.fill = false;
		this.color = Color.BLACK;
		this.paintPath = false;
	}

	/**
	 * @return Returns the color.
	 */
	public Color getColor() {
		return color;
	}

	/**
	 * @param color
	 *            The color to set.
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/**
	 * @return Returns the fill.
	 */
	public boolean isFill() {
		return fill;
	}

	/**
	 * @param fill
	 *            The fill to set.
	 */
	public void setFill(boolean fill) {
		this.fill = fill;
	}

	/**
	 * @return Returns the paintPath.
	 */
	public boolean isPaintPath() {
		return paintPath;
	}

	/**
	 * @param paintPath
	 *            The paintPath to set.
	 */
	public void setPaintPath(boolean paintPath) {
		if (paintPath == true) {
			thePathPainter = new PathPainter();
		}
		this.paintPath = paintPath;
	}

	/**
	 * @return Returns the thePathPainter.
	 */
	public PathPainter getThePathPainter() {
		return thePathPainter;
	}

	/**
	 * @param thePathPainter
	 *            The thePathPainter to set.
	 */
	public void setThePathPainter(PathPainter thePathPainter) {
		this.thePathPainter = thePathPainter;
	}

	public MovingObjectPainter(boolean fill, Color color) {
		this.fill = fill;
		this.color = color;
		setPaintPath(true);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see simulation.visualization.IPainter#paint(java.awt.Graphics2D,
	 *      java.lang.Object)
	 */
	public void paint(Graphics2D g, Object o) {
		IMovingObject movingObject = (IMovingObject) o;
		int size = 10;
		int x = (int) (movingObject.getLocation().getX());
		int y = (int) (movingObject.getLocation().getY());
		g.setColor(color);
		if (fill) {
			g.fillOval(x - size / 2, y - size / 2, size, size);
		} else {
			g.drawOval(x - size / 2, y - size / 2, size, size);
		}
		if ((movingObject instanceof IPathRecorder) && paintPath) {
			// paintPath(g, ugv.getRecordedPath());
			Path recordedPath = ((IPathRecorder) movingObject)
					.getRecordedPath();
			if (recordedPath != null) {
				thePathPainter.paint(g, recordedPath);
			}
		}
	}

	private void paintPath(Graphics2D g, Path path) {
		if (path == null) {
			return;
		}
		Location lastLocation = null;
		// Polygon p = new Polygon();
		// Collections.synchronizedList();
		synchronized (path) {
			for (Iterator iter = path.getLocationList().iterator(); iter
					.hasNext();) {
				Location element = (Location) iter.next();
				if (lastLocation != null) {
					Point2D p1 = new Point2D.Double(lastLocation.getX(),
							lastLocation.getY());
					Point2D p2 = new Point2D.Double(element.getX(), element
							.getY());
					g.drawLine((int) p1.getX(), (int) p1.getY(), (int) p2
							.getX(), (int) p2.getY());
				}
				lastLocation = element;
				// p.addPoint((int) element.getX(), (int) element.getY());
			}
		}
		// g.draw(p);
	}
}