/*

 * Created on Nov 12, 2004

 *

 * TODO To change the template for this generated file go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

package yaes.ui.visualization;



import java.awt.BasicStroke;

import java.awt.Color;

import java.awt.Graphics2D;

import java.awt.geom.AffineTransform;

import java.util.ConcurrentModificationException;

import java.util.Iterator;

import yaes.framework.world.network.cluster.ClusterHead;

import yaes.framework.world.network.sensornetwork.SensorNode;

import yaes.framework.world.network.sensornetwork.SensorNetwork;

import yaes.ui.text.TextUi;



/**

 * @author Lotzi Boloni

 *

 * TODO To change the template for this generated type comment go to

 * Window - Preferences - Java - Code Style - Code Templates

 */

public class NetworkPainter implements IPainter {



    int scale = 1;

    int netscale = 5;



    /* (non-Javadoc)

     * @see yaes.ui.visualization.IPainter#paint(java.awt.Graphics2D, java.lang.Object)

     */

    public void paint(Graphics2D g, Object o) {

        SensorNetwork network = (SensorNetwork) o;

        AffineTransform theTransform = new AffineTransform();

        theTransform.scale(scale, scale);

        g.setTransform(theTransform);

        synchronized (network) {

            for (Iterator iter = network.nodeInfoList.iterator(); iter

                    .hasNext();) {

                SensorNode element = (SensorNode) iter.next();

                paintNode(g, element, network);

            }

            for (Iterator iter = network.failedNodes.iterator(); iter.hasNext();) {

                SensorNode element = (SensorNode) iter.next();

                paintNode(g, element, network);

            }

        }

    }



    public void paintNode(Graphics2D g, SensorNode node, SensorNetwork network) {

        int interiorCircle = 16;

        int exteriorCircle = 27;

        BasicStroke stroke = new BasicStroke(1);

        g.setStroke(stroke);

        // first paint the interior circle, depending of the remaining energy

        double percentageEnergy = node.getEnergyModel().getEnergy()

                / node.getEnergyModel().getMaximumEnergy();

        if (percentageEnergy >= 0.3) {

            g.setColor(Color.GREEN);

        } else if (percentageEnergy >= 0.1) {

            g.setColor(Color.YELLOW);

        } else {

            g.setColor(Color.RED);

        }

        g.fillOval(netscale * node.getXcord() - interiorCircle / 2, netscale

                * node.getYcord() - interiorCircle / 2, interiorCircle,

                   interiorCircle);

        g.setColor(Color.BLACK);

        g.drawOval(netscale * node.getXcord() - interiorCircle / 2, netscale

                * node.getYcord() - interiorCircle / 2, interiorCircle,

                   interiorCircle);

        // if this is a clusterhead

        ClusterHead theClusterHead = node.getClusterHead();

        if (theClusterHead == null) {

            return;

        }

        // draw the clusterhead mark

        stroke = new BasicStroke(3);

        g.setStroke(stroke);

        g.setColor(Color.BLACK);

        g.drawOval(netscale * node.getXcord() - exteriorCircle / 2, netscale

                * node.getYcord() - exteriorCircle / 2, exteriorCircle,

                   exteriorCircle);

        // now, draw the thin lines to the nodes part of the cluster

        stroke = new BasicStroke(1);

        g.setStroke(stroke);

        for (Iterator it2 = theClusterHead.getClusterContentIterator(); it2

                .hasNext();) {

            SensorNode member = (SensorNode) it2.next();

            g.drawLine(netscale * node.getXcord(), netscale * node.getYcord(),

                       netscale * member.getXcord(), netscale

                               * member.getYcord());

        }

        // now, draw the thick lines to the neighboring clusterheads

        stroke = new BasicStroke(3);

        g.setStroke(stroke);

        try {

            for (Iterator it2 = theClusterHead.clusterNeighborList.iterator(); it2

                    .hasNext();) {

                ClusterHead nb = (ClusterHead) it2.next();

                SensorNode nbnode = nb.getTheNode();

                g.drawLine(netscale * node.getXcord(), netscale

                        * node.getYcord(), netscale * nbnode.getXcord(),

                           netscale * nbnode.getYcord());

            }

        } catch(ConcurrentModificationException cmex) {

            TextUi.println(".");

        }

        

    }

}

